//KEYBOARD HANDLER REFERENCE
//http://www.quirksmode.org/js/keys.html
//http://unixpapa.com/js/key.html
//SELECTION STUFF
//http://stackoverflow.com/questions/16095155/javascript-contenteditable-set-cursor-caret-to-index
//



/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
//
//	C a d e t T a b l e
//
/////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////
(function  () {

$(document).ready (function () {

	//alert("CCTABLE function called");

	var moduleName = "CadetTable"; // constructor
	var instanceCount = 0;

	// here we assign the constructor to the global variable, but we could assign an instance if we wanted to provide a singleton
	var module = window[moduleName] = Module;

	/*
		function Module (userOptions) {
		var options = {
			_theTable: null,
		}; // defaults
		//options = _.extend (options, userOptions);
	*/	
	
	function Module (tableName, $t) {
		/// PRIVATE INSTANCE VARIABLES	
		var _returnPending = false;
		var _editor=null;
		var _tableID = tableName;	//table name as string (id string)
		var _tableElement = document.getElementById(_tableID);//table as DOM element;
		var _tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
		var _theadElement = _tableElement.getElementsByTagName("thead")[0];
		var _inContentColumn = false;
		var mud = "#"+_tableID;
		//var _tableQO = $(mud);	//table as query object
		var _$tqo = $t; //table query object
		var _currentRow = -1;
		var options = {
			_theTable: null,
		}; // defaults
		//options = _.extend (options, userOptions);
		var _ccdebugon = false; //true;
		//var _bgnormal = "#ffffff";
		var _bgnormal = "";
		var _bghilite = "#ffeeff";


		///PUBLIC METHODS
		this.initTable = initTable;
		this.setEditor = setEditor;
		this.getCurrentRow = getCurrentRow;
		this.setCurrentRow = setCurrentRow;
		this.addRowAt = addRowAt;
		this.addRowBefore = addRowBefore;
		this.addRowAfter = addRowAfter;
		this.deleteEvent = deleteEvent;
		this.deleteSomeEvent = deleteSomeEvent;
		this.clear = clear;
		this.clearAndLeaveSingle = clearAndLeaveSingle;
		this.getCellValue = getCellValue;	// param message object containing .text, .captionStyle, .rollupType, .rollupBase, etc.
		this.getText = getText;	
		this.setText = setText;	
		this.getHtmlText = getHtmlText;
		this.setHtmlText = setHtmlText;
		this.getSectionHtml = getSectionHtml;
		this.getTextAlign = getTextAlign;
		this.setTextAlign = setTextAlign;
		this.getTextVAlign = getTextVAlign;
		this.setTextVAlign = setTextVAlign;
		//this.textAlignLeft = textAlignLeft;
		//this.textAlignCenter = textAlignCenter;
		//this.textAlignRight = textAlignRight;
		this.makeBold = makeBold;
		this.makeItalic = makeItalic;
		this.makeUnderline = makeUnderline;
		this.makeColor = makeColor;
		this.makeBGColor = makeBGColor;
		this.setIntime = setIntime;
		this.getIntime = getIntime;
		this.setOuttime = setOuttime;
		this.getOuttime = getOuttime;
		this.cueIntime = cueIntime;
		this.syncToTime = syncToTime;
		this.capDisplayedAtTime = capDisplayedAtTime;
		this.setRowValues = setRowValues;
		this.getSelectedText = getSelectedText;
		this.setCurrentText = setCurrentText
		this.getLength = getLength;
		this.inContentColumn = inContentColumn;
		this.refreshCaptions = refreshCaptions;
		this.setSelectionCurrentRowToBeginning = setSelectionCurrentRowToBeginning;
		this.setSelectionCurrentRowToEnd = setSelectionCurrentRowToEnd;
		this.insertCurrentRowSelectionText = insertCurrentRowSelectionText;
		this.insertNewline = insertNewline;
		this.setEditMode = setEditMode;
		this.UIsetProjectFile = UIsetProjectFile
		this.UIsetMedia = UIsetMedia;
		this.insertMusicalNote = insertMusicalNote;
		this.newProject = newProject;
		this.setupMediaPlayer = setupMediaPlayer;
		this.fooTest = fooTest;
		this.fooTest2 = fooTest2;
		this.playerIsPaused = playerIsPaused;
		this.scrollToRow = scrollToRow;
		this.focusCaptionCell = focusCaptionCell;
		this.getRowCount = getRowCount;
		this.setSectionHtml = setSectionHtml
		this.setCellHtml = setCellHtml
		this.clearCurrentTimes = clearCurrentTimes;
		this.clearAllTimes = clearAllTimes;
		this.clearOutTimes = clearOutTimes;
		this.gotoCurrent = gotoCurrent;
		this.markRow = markRow;
		this.unmarkAll = unmarkAll;
		this.updateRowNumbers = updateRowNumbers;
		this.justFocusCaptionCell = justFocusCaptionCell;
		this.focusCurrentRowCaptionCell = focusCurrentRowCaptionCell;
		this.setCadetMode = setCadetMode;
		this.updateDialogTime = updateDialogTime;
		this.setCueText = setCueText;
		this.getCueText = getCueText;
		this.showHideRuler = showHideRuler;
		this.convertToDvsShell = convertToDvsShell;
		this.unsetupMediaPlayerLocal = unsetupMediaPlayerLocal;
		this.combineRowWithPreviousRow = combineRowWithPreviousRow;
		this.startMediaTimer = startMediaTimer;
		this.stopMediaTimer = stopMediaTimer;


		//initialize a new table
		debug("TABLE: calling initTable()");
		initTable();
		
		function fooTest(){
			var stuff = extractBlockContentsFromCaret();
			//insert it at beginning of next row
			setCurrentRow(getCurrentRow()+1);
			setSelectionCurrentRowToBeginning();
			debug("TABLE:fooTest: firstChild.outerHTML=["+stuff.firstChild.innerHTML+"]");
			document.execCommand("insertHTML", false, stuff.firstChild.innerHTML);
		}//fooTest
		function fooTest2(){
			var stuff = extractBlockContentsToCaret();
			//insert it at beginning of next row
			setCurrentRow(getCurrentRow()-1);
			setSelectionCurrentRowToEnd();
			debug("TABLE:fooTest2: firstChild.outerHTML=["+stuff.firstChild.innerHTML+"]");
			document.execCommand("insertHTML", false, stuff.firstChild.innerHTML);
		}//fooTest
		
		function showHideRuler(b){
			//if showing, convert all captions to mono, then show ruler in current row; if hiding, kill ruler and remove mono for all captions
			RULER_SHOWING = b;
			if( b ){
				//$("#ruler").show();
				for( var i=0; i<getRowCount(); i++ ){
					$(_tbodyElement.rows[i].cells[COL_TEXT]).addClass("mono");
				}
				showRuler(getCurrentRow());
				//$("#showHideRuler").addClass("dropdown-item-checked");
				$("#rulertext").text("Hide Ruler");
			} else {
				//$("#rulerx").hide();
				for( var i=0; i<getRowCount(); i++ ){
					$(_tbodyElement.rows[i].cells[COL_TEXT]).removeClass("mono");
				}
				killRuler();
				//$("#showHideRuler").removeClass("dropdown-item-checked");
				$("#rulertext").text("Show Ruler");
			}
			justFocusCaptionCell();			
		}//setFont
		/*
		function moveRulerAtopRow(i){
			var eTop = $(_tbodyElement.rows[i].cells[COL_TEXT]).offset().top - $(".editor").offset().top -25; //get the offset top of the element
			var eLeft = $(_tbodyElement.rows[i].cells[COL_TEXT]).offset().left;
			$("#ruler").show();
			//$("#ruler").parent().css({position: 'relative'});
			$("#ruler").css({top: eTop, left: eLeft});
		}//moveRulerAtopRow	
		*/
		function showRuler(i){
			$(".rulerx").remove();
			//$(_tbodyElement.rows[i].cells[COL_TEXT]).addClass("mono");
			$(_tbodyElement.rows[i].cells[COL_TEXT]).prepend("<div class='rulerx'>12345678901234567890123456789012</div>")
			//$("#rulerx").show();
		}//moveRulerAtopRow	
		function killRuler(){
			//for( var i=0; i<getRowCount(); i++ ){
			//	$(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT]).removeClass("mono");
			//}
			$(".rulerx").remove();
		}//killRuler	
		
		function getLength(){
			return _tbodyElement.rows.length;
		}//getLength
		function inContentColumn(){
			return _inContentColumn;
		}//inContentColumn

		function initTable(){
		
				
				////////////////////////////////
				//  Retrieve CONFIG values
				$.post("/configread/", { thedata: {} }, function(temp) {
					var o;
					if( temp.length > 0 ){
						o = JSON.parse(temp);
						//debug("EDITOR:init:post(/configread/ success response=["+JSON.stringify(o,null,2)+"]");
						
						//webroot
						if( typeof o.defaults.webroot != "undefined" ) _webroot = o.defaults.webroot;

						// scrubbing increments
						if( typeof o.defaults.jumpTiny != "undefined" ) JUMP_TINY = o.defaults.jumpTiny;
						if( typeof o.defaults.jumpSmall != "undefined" ) JUMP_SMALL = o.defaults.jumpSmall;
						if( typeof o.defaults.jumpLarge != "undefined" ) JUMP_LARGE = o.defaults.jumpLarge;
						//return-return time adjust
						if( typeof o.defaults.returnreturnadjust != "undefined" ) RETURNRETURNADJUST = o.defaults.returnreturnadjust;
						
						//includeMediaMap
						if( typeof o.defaults.includeMediaMap != "undefined" ) INCLUDE_MEDIA_MAP = o.defaults.includeMediaMap;
						
						//DVS
						if( typeof o.defaults.readingwpm != "undefined" ) READING_SPEED = o.defaults.readingwpm;
						if (typeof o.defaults.usetts != "undefined")
							DVS_TTS_ON = o.defaults.usetts;
						
						//DOUBLE_CR_ESTIMATES_INTIME
						if( typeof o.defaults.doubleCRestimatesIntime != "undefined" ) DOUBLE_CR_ESTIMATES_INTIME = o.defaults.doubleCRestimatesIntime; 
						
						//Screen reader captions
						if (typeof o.defaults.srcaptions != "undefined"){
							SR_CAPTIONS_ON = o.defaults.srcaptions;
							
							if( SR_CAPTIONS_ON )
								setTimeout(function(){$("#srcaptionsdiv").html("Captions set to trigger screen readers. You can change this setting in tools preferences.");}, 
								1000);
							else
								setTimeout(function(){$("#srcaptionsdiv").html("");}, 
								1000);
							
						}
						
						// debug visibility
						if( typeof o.defaults.debugVisible != "undefined" ) DEBUG = o.defaults.debugVisible;
						makeDebugVisible( DEBUG );
						
						//default colors
						if( typeof o.defaults.foreColor != "undefined" ) DEFAULT_FORECOLOR = o.defaults.foreColor;
						if( typeof o.defaults.backColor != "undefined" ) DEFAULT_BACKCOLOR = o.defaults.backColor;
						
						//QONCLICK
						if( typeof o.defaults.qOnClickInEdit != "undefined" ) QONCLICKINEDIT = o.defaults.qOnClickInEdit;
						if( typeof o.defaults.qOnClickInReview != "undefined" ) QONCLICKINREVIEW = o.defaults.qOnClickInReview;
						var foo=true;
						
						//debug("TABLE:initTable DEFAULT_FORECOLOR=["+DEFAULT_FORECOLOR+"]");
					}
			
				})
				.fail( function(xhr, textStatus, error) {
					debug("EDITOR:init:post(/configread/: failure xhr.status=["+xhr.status+"] xhr.responseText=["+xhr.responseText+"]");
				});
		
		
		

		
		
			//debug("TABLE: initTable");
			//alert("initTable: _tableID=["+_tableID+"] html=["+$('#'+_tableID).html()+"]");
			//$("#"+_tableID).html("<thead><tr><th>#</th><th>START</th><th>END</th><th>CAPTION</th></tr></thead><tbody class='scrollable-table-body'></tbody>");
			//_$tqo.html("<thead><tr><th>#</th><th>START</th><th>END</th><th class='textAlignCenter'>CAPTION</th></tr></thead><tbody class='scrollable-table-body'></tbody>");
			_$tqo.html("<thead>&nbsp;</thead><tbody class='scrollable-table-body'>&nbsp;</tbody>");
			setCadetMode(_cadetMode);//(_cadetMode);CADETMODE_DESCRIPTION
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			//$("#"+_tableID+" tbody").html("<tr><td>1</td><td class='time-column'><section class='time-column' contenteditable>00:00:00.00</section></td><td class='time-column'><section class='time-column' contenteditable>24:00:00.00</section></td><td class='content-column'><section class='content-column' contenteditable style='color:#fefefe; background-color:#010101;'>"+DEFAULT_CAPTION+"</section></td></tr>")
			
			
			//$("#"+_tableID+" tbody").html("<tr><td>1</td><td class='time-column'><section class='time-column' contenteditable>"+ZEROS+"</section></td><td class='time-column'><section class='time-column' contenteditable>"+INFINITY+"</section></td><td class='content-column'><section class='content-column' contenteditable style='color:#fefefe; background-color:#010101;'>"+DEFAULT_CAPTION+"</section></td></tr>")
			//addRowAt(0, ZEROS, INFINITY, DEFAULT_CAPTION);
			debug("TABLE:initTable: calling addRowAt with blanks");
			addRowAt(0, "", "", DEFAULT_CAPTION);
					
			
			_theadElement = _tableElement.getElementsByTagName("thead")[0];
			
			
			//make rows clickable to set currentRow
			$(_$tqo, 'tbody').delegate("tr", "click", function(e) {
				_returnPending = false;	//reset the boolean
				
				if( e.originalEvent.shiftKey ){
					//doStatus("shift click");
					if( !bMarking ){
						//doStatus("shift click: setting bMarking");
						bMarking = true;
					}
					if( markRow1 < 0 ){	//set first mark if not yet set
						markRow1 = _currentRow;
						//doStatus("shift click: mark1=["+markRow1+"]");
					}
				} else {
					//doStatus("click marking false");
					bMarking = false;
					markRow1 = -1;
					markRow2 = -1;
					unmarkAll();
				}				
				
				setCurrentRow($(e.currentTarget).index());
				//cue video to intime
				//debug("TABLE:tbody.click: _editMode=["+_editMode+"]");
				if( _editMode == EDITMODE_TRANSCRIBE ){	//only for TRANSCRIBE (EDIT) trap row click
					//debug("TABLE:tbody.click: cueing intime");
					if( QONCLICKINEDIT )
						cueIntime(_currentRow);
				} else { //REVIEW MODE
					if( QONCLICKINREVIEW )
						cueIntime(_currentRow);
				}	
				//debug("TABLE:clickDelegate: get selection point and set style button states here");
				
				if( e.originalEvent.shiftKey ){
					if( bMarking ){
						unmarkAll()
						markRow2 = getCurrentRow();
						//doStatus("shift click: mark2=["+markRow2+"]");
						markRows(markRow1, markRow2);
					}
				}
			});
			

			$(_$tqo, 'tbody', '.content-column').delegate("td.content-column", "keydown", function(e) {
				//debug("TABLE:tbody:td.content-column:keydown:");
				_inContentColumn = true;
				//_returnPending = false;	//reset the boolean
				keyDownHandler($(e.currentTarget).index(), e);
			});	
			$(_$tqo, 'tbody', '.content-column').delegate("td.content-column", "keyup", function(e) {
				//debug("TABLE:tbody:td.content-column:keyup:");
				//keyUpHandler($(e.currentTarget).index(), e);
								
				_editor.toggleAutoRefreshCaptions(true);
				updateDialogTime();
			});
			/* DON'T TRAP KEYDOWN for TIME COLUMN, USE KEYPRESS (below), NEED ACTUAL KEYS
			$(_$tqo, 'tbody', '.time-column').delegate("td.time-column", "keydown", function(e) {
				debug("TABLE:tbody:td.time-column:keydown:");
				_inContentColumn = false;
				keyDownHandler($(e.currentTarget).index(), e);
			});	
			*/
			$(_$tqo, 'tbody', '.time-column').delegate("td.time-column", "keypress", function(e) {
				//debug("TABLE:tbody:td.time-column:keypress:");
				_inContentColumn = false;
				//_returnPending = false;	//reset the boolean
				keyPressHandler(e);
				updateDialogTime();
			});	
			$(_$tqo, 'tbody', '.content-column').delegate("td.content-column", "click", function(e) {
				//debug("TABLE:content-column:click: InContentColumn");
				_returnPending = false;	//reset the boolean
				_inContentColumn = true;
				//save current selection point for if needed...
				_selPoint = getSelectedText().getRangeAt(0);
			});
			
			$(_$tqo, 'tbody', '.content-column').delegate("td.content-column", "focusout", function(e) {
				//debug("TABLE:content-column:blur focusOut");
			});	
			$(_$tqo, 'tbody', '.content-column').delegate("td.content-column", "focusin", function(e){
				//debug("TABLE:content-column: focusIn");
			});	
			/**/
			
			$(_$tqo, 'tbody', '.time-column').delegate("td.time-column", "click", function(e) {
				//debug("TABLE:time-column:click: InTimeColumn");
				_returnPending = false;	//reset the boolean
				_inContentColumn = false;
			});	
			$(_$tqo, 'tbody', '.time-column').delegate("td.time-column", "focusout", function(e) {
				//debug("TABLE:tbody:td.time-column:focusout:");
				//validate timecode;
				focusOutHandler(e);
			});	
			$(_$tqo, 'tbody', '.cue-column').delegate("td.cue-column", "click", function(e) {
				//debug("TABLE:time-column:click: InTimeColumn");
				_returnPending = false;	//reset the boolean
				_inContentColumn = false;
			});	
			$(_$tqo, 'tbody', '.cue-column').delegate("td.cue-column", "focusout", function(e) {
				//debug("TABLE:tbody:td.time-column:focusout:");
				//validate timecode;
				focusOutHandler(e);
			});	
			
			//GLOBAL WINDOW KEYBOARD SHORTCUT HANDLER
			/*
			*/	
			$(document).keydown(function(e){
				//debug("TABLE:document keydown:");
				windowKeyDownHandler(e);
			});	
			
			
			// Update the seek bar as the video plays
			/*
			$("video")[0].addEventListener("timeupdate", function() {
				//debug("TABLE: video timeupdate");
				// Calculate the slider value
				var value = $("video")[0].currentTime;

				// Update the text field
				$("#mediatime")[0].value = value.toTimecode();
			});
			*/
			
			/////////////////////////////
			// RESIZE editor
			var resizerHandle = $('#resizer'),
				isResizing = false,
				originalX, originalY,
				lastDownX = 0,
				lastDownY = 0;
			resizerHandle.on('mousedown', function (e) {
				//doStatus("resizer mousedown");
				isResizing = true;
				originalX = $(".editor").width();
				originalY = $("#divtable").height();
				lastDownX = e.clientX;
				lastDownY = e.clientY;
				//debug("resizing start lastDownX=["+lastDownX+"]");
			});
			/*
			$(document).on('mousemove', function (e) {
				// we don't want to do anything if we aren't resizing.
				if (!isResizing) 
					return;

				var deltaX = e.clientX - lastDownX,
					deltaY = e.clientY - lastDownY;
				//debug("resizing during deltaX=["+deltaX+"]");
				$(".editor").css('width', originalX+deltaX +"px");
				$("#divtable").css('height', originalY+deltaY +"px");
			}).on('mouseup', function (e) {
				if (!isResizing) 
					return;
				// stop resizing
				isResizing = false;
				//debug("resizing stop");
			});	
			*/			
			/////////////////////////////
			// RESIZE player
			var resizerPlayerHandle = $('#resizerplayer'),
				isPlayerResizing = false,
				originalX, originalY,
				lastDownX = 0,
				lastDownY = 0;
			resizerPlayerHandle.on('mousedown', function (e) {
				//doStatus("resizerplayer mousedown");
				isPlayerResizing = true;
				ccDisplay.clearCaptions();
				originalX = $("#cadetplayer").width();
				originalY = $("#cadetplayer").height();
				lastDownX = e.clientX;
				lastDownY = e.clientY;
				targetPlayerSize.width = $("#cadetplayerwrapper").width();
				targetPlayerSize.height = $("#cadetplayerwrapper").height();
				//debug("resizing start lastDownX=["+lastDownX+"]");
			});
			var targetPlayerSize={};
			targetPlayerSize.width = $("#cadetplayerwrapper").width();
			targetPlayerSize.height = $("#cadetplayerwrapper").height();
			$(document).on('mousemove', function (e) {
				// we don't want to do anything if we aren't resizing.
				if (isPlayerResizing || isResizing ){
					if( isPlayerResizing ){
						//doStatus("player resizing")
						
						switch(mediaLocationType){
							case MEDIA_LOCATION_LOCAL:
								var deltaX = e.clientX - lastDownX,
									deltaY = e.clientY - lastDownY;
								//debug("resizing during deltaX=["+deltaX+"]");
								$("#cadetplayer").css('width', originalX-deltaX +"px");
								$("#cadetplayer").css('height', originalY+deltaY +"px");
								return;
								break;
				
							case MEDIA_LOCATION_YT:
								var deltaX = e.clientX - lastDownX,
									deltaY = e.clientY - lastDownY;
								//debug("resizing during deltaX=["+deltaX+"]");
								//$("#cadetplayer").css('width', originalX-deltaX +"px");
								//$("#cadetplayer").css('height', originalY+deltaY +"px");
								targetPlayerSize.width = $("#cadetplayerwrapper").width() - deltaX;
								targetPlayerSize.height = $("#cadetplayerwrapper").height() + deltaY;
								PlayerDispatch.dragResizePlayer(targetPlayerSize.width,targetPlayerSize.height);
								return;
								break;
				
							case MEDIA_LOCATION_VIMEO:
								var deltaX = e.clientX - lastDownX,
									deltaY = e.clientY - lastDownY;
								//debug("resizing during deltaX=["+deltaX+"]");
								//$("#cadetplayer").css('width', originalX-deltaX +"px");
								//$("#cadetplayer").css('height', originalY+deltaY +"px");
								$("#remoteSubstitute").css("display","none");
								targetPlayerSize.width = $("#cadetplayerwrapper").width() - deltaX;
								targetPlayerSize.height = $("#cadetplayerwrapper").height() + deltaY;
								//PlayerDispatch.dragResizePlayer(targetPlayerSize.width,targetPlayerSize.height);
								$("#cadetplayer").css('width', originalX-deltaX +"px");
								$("#cadetplayer").css('height', originalY+deltaY +"px");
								return;
								break;
				
							default:
								break;
						}
						
					}
					if( isResizing ){
						//doStatus("resizing")
						var deltaX = e.clientX - lastDownX,
							deltaY = e.clientY - lastDownY;
						//debug("resizing during deltaX=["+deltaX+"]");
						$(".editor").css('width', originalX+deltaX +"px");
						$("#divtable").css('height', originalY+deltaY +"px");
						return;
					}
				} else {
					return;
				}
			}).on('mouseup', function (e) {
				//debug("resizing stop");
				
				
				
				if (isPlayerResizing || isResizing ){
					if( isPlayerResizing ){
						isPlayerResizing = false;
						
						switch(mediaLocationType){
							case MEDIA_LOCATION_LOCAL:
								//var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + $("#cadetvideo").height()+ $("#resizerplayer").height() + 9;
								//$("#cadetplayer").css('height', ifoo +"px");
								//doStatus("setting cadetplayer height=["+ifoo+"]");
						
								//var iheight= $("#cadetplayer").height() - $("#localProjectFile").height() - $("#localMediaFile").height() - $("#playSpeedDiv").height() - $("#resizerplayer").height() + 9;
								var iheight = $("#resizerplayer").offset().top - $("#playSpeedDiv").offset().top;
								var iwidth = $("#resizerplayer").width()
								//PlayerDispatch.dragResizePlayer(iwidth,iheight);
								PlayerDispatch.dragResizePlayer(targetPlayerSize.width,targetPlayerSize.height);
								return;
								break;
				
							case MEDIA_LOCATION_YT:
								var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + targetPlayerSize.height + $("#resizerplayer").height() + 4;
								$("#cadetplayerRemote").css('height', targetPlayerSize.height +"px");
								$("#cadetplayer").css('height', ifoo +"px");
								$("#cadetplayer").css('width', targetPlayerSize.width+4 +"px");
								PlayerDispatch.editor.focusCurrentRowCaptionCell();
								return;
								break;
				
							case MEDIA_LOCATION_VIMEO:
								var ifoo = $("#localProjectFile").height() + $("#localMediaFile").height() + $("#playSpeedDiv").height() + targetPlayerSize.height + $("#resizerplayer").height() + 4;
								//$("#cadetplayer").css('width', targetPlayerSize.width+4 +"px");
								oldOuterWidth = targetPlayerSize.width;
								oldOuterHeight = targetPlayerSize.height;
								$("#cadetplayerRemote").css({"height":targetPlayerSize.height +"px","width":targetPlayerSize.width+"px"});
								$("#cadetplayer").css('height', ifoo +"px");
								$("#remoteSubstitute").css({"display":"", top});
								//VimeoPlayer.player.destroy();
								//$("#remoteSubstitute").html("");
								setTimeout(PlayerDispatch.resizePlayerObject,1000);
								/**/
								setTimeout(function(){
										targetPlayerSize.width = $("#cadetplayerwrapper").width();
										targetPlayerSize.height = $("#cadetplayerwrapper").height();
										oldOuterWidth = targetPlayerSize.width;
										oldOuterHeight = targetPlayerSize.height;
										PlayerDispatch.resizePlayerObject();//second time seems to recenter picture
										$("#cadetplayerRemote").css({"height":targetPlayerSize.height +"px","width":targetPlayerSize.width+"px"});
										$("#cadetplayer").css('height', ifoo +"px");
										PlayerDispatch.editor.focusCurrentRowCaptionCell();
								},2000);
								
								return;
								break;
				
							default:
								break;
						}
						
						
						
						
					}
					if( isResizing ){
						isResizing = false;
						return;
					}
				} else {
					return;
				}
			});	
			
			//catch mouseclicks on  players
			/**/
			//this is for remote player which happens in iframes
			window.addEventListener('blur',function(){
				if(myMouseObj.iframeMouseOver){
					//doStatus('Wow! Iframe Click!');
					setTimeout(PlayerDispatch.editor.focusCurrentRowCaptionCell,1000);
				}
			});
			document.getElementById('cadetplayerwrapper').addEventListener('mouseover',function(){
			   myMouseObj.iframeMouseOver = true;
			});
			document.getElementById('cadetplayerwrapper').addEventListener('mouseout',function(){
				myMouseObj.iframeMouseOver = false;
			});	
			//this is for local player	
			document.getElementById('cadetplayerwrapper').addEventListener('mouseup',function(){
					setTimeout(PlayerDispatch.editor.focusCurrentRowCaptionCell,1000);
			});		
			
			
						
			//add a single default row
			//setCurrentRow(1);
			setCurrentRow(0);
			
			//focus caption cell
			//_tableElement.rows[1].cells[COL_TEXT].focus();
			_tbodyElement.rows[0].cells[COL_TEXT].focus();
			
			//select all text and set to default fore/background color
			selectAll(_tbodyElement.rows[0].cells[COL_TEXT].firstChild); 
			makeColor(DEFAULT_FORECOLOR);//"white");
			makeBGColor(DEFAULT_BACKCOLOR);//"black");  

			setSelectionCurrentRowToBeginning();


        	setCadetMode( CADETMODE_CAPTION );
			
			//set editMode
        	setEditMode( EDITMODE_TRANSCRIBE );
        	
        	//UIsetWebFile(_cfg);
        	
        	//startMediaTimer();
        	
			
		}//initTable
			
		var timerMediaTimer = null;
		var inextevent=-1;
		readLast = false;
		var currentRemoteCaptionIndex = -1;
		var nextRemoteCaptionIndex = -1
		var currentRemoteHtmlText = "";
		var nextRemoteHtmlText = "";
		var currentAlign = -1;
		var nextAlign = -1
		var currentVAlign = -1;
		var nextVAlign = -1
		var lastRemotePausedIntime = -1;
		var lastRemotePausedOuttime = -1;
		var lastRemotePausedHTML = "";
		
		function startMediaTimer(){
			//debug("TABLE: after initTable: enter startMediaTimer");
			if( timerMediaTimer )
				stopMediaTimer();
			inextevent=-1;
			readLast = false;
			currentRemoteCaptionIndex = -1;
			nextRemoteCaptionIndex = -1
			currentRemoteHtmlText = "";
			nextRemoteHtmlText = "";
			currentAlign = -1;
			nextAlign = -1
			currentVAlign = -1;
			nextVAlign = -1
			lastRemotePausedIntime = -1;
			lastRemotePausedOuttime = -1;
			lastRemotePausedHTML = "";
			timerMediaTimer = setInterval( mediaTimerFunc, 30 );
		}//startMediaTimer
		function stopMediaTimer(){
			clearInterval(timerMediaTimer);
			timerMediaTimer = null;
		}//stopMediaTimer
		
		//periodic refresh of playhead time and 
		function mediaTimerFunc() {
			
			// Calculate the slider value
			if( _editor.getMediaFilename() === null && mediaUrl == "" ){
				//debug("TABLE: interval for video time: no video loaded value=["+value+"]");
				return;
			}				
			
			/*
			var value = 0.0; //$("video")[0].currentTime;
			var thetype = _editor.getMediaLocationType();
			if( thetype == MEDIA_LOCATION_LOCAL ){
				value = $("video")[0].currentTime;
			} else if( thetype == MEDIA_LOCATION_YT ){
				doStatus("yt time");
				value = YTplayer.gettime();
			}
			*/
			
			if( mediaLocationType == MEDIA_LOCATION_VIMEO ){
				VimeoPlayer.player.getCurrentTime().then(function(time) {
					VimeoPlayer.time = time;
				}).catch(function(error) {
					// an error occurred
					return 0.0
				});
				
				VimeoPlayer.player.getPaused().then(function(paused) {
					// paused = whether or not the player is paused
					VimeoPlayer.paused = paused;
				}).catch(function(error) {
					// an error occurred
				});
			}
			
			var value = PlayerDispatch.playerGetTime();
			var svalue = (typeof value !== 'undefined')?value.toTimecode():"";
			var currentEndTime = getOuttime(getCurrentRow()).timecodeToNumber();

			// Update the playhead time display
			//debug("TABLE: interval for video time: time update value=["+value+"]");
			
			$("#mediatime")[0].value = svalue;
			/*
			switch(mediaLocationType){
				case MEDIA_LOCATION_LOCAL:
					$("#mediatime")[0].value = svalue;
					break;
				case MEDIA_LOCATION_YT:
					$("#mediatime")[0].value = svalue;
					break;
				case MEDIA_LOCATION_VIMEO:
					//vimeo only returns a promise, so it'll set the time itself
					break;
				default:
					$("#mediatime")[0].value = svalue;
					break;
			}
			*/
			
			//display current caption if in REVIEW mode
			var stream = document.getElementById('cadetvideo');
			//debug("TABLE:setInterval: paused=["+stream.paused+"]");
			
			/*
			if( _editMode == EDITMODE_REVIEW && !stream.paused){
				//debug("TABLE:setInterval: REVIEW mode");
				var curout = getOuttime(_currentRow).timecodeToNumber();
				if( curout == -1 ){//blank, so use next intime
					//debug("setInterval:REVIEW: blank at currow, trying next intime");
					if( _currentRow < getRowCount()-1 ){
						curout = getIntime(_currentRow+1).timecodeToNumber();
						//debug("setInterval:REVIEW: blank at currow, got next intime=["+curout.toTimecode()+"]");
					}
				}
				//debug("TABLE:setInterval: val=["+value+"] curout=["+curout+"]");
				//debug("TABLE:setInterval: paused=["+stream.paused+"]");
				if( value >= curout ){
					setCurrentRow(_currentRow+1);
					setSelectionToHere(_tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild, 0);
					//make sure current row is in view
					scrollToRow(getCurrentRow());
					
					//speak text if in DVS mode
					if( _cadetMode == CADETMODE_DESCRIPTION )
							responsiveVoice.speak(getText(getCurrentRow()));//,"UK English Female",{rate: 1.5});
				}
			}
			*/
			
			if(PlayerDispatch.playerIsPaused()) //if( stream.paused )
				ttsCancel();//responsiveVoice.cancel();
			
			inextevent = getCurrentRow() + 1;
			if( inextevent == getRowCount() )
				inextevent = getRowCount()-1;
			if( _editMode == EDITMODE_REVIEW && !PlayerDispatch.playerIsPaused() && inextevent<getRowCount()){
				//doStatus("timer EDITMODE_REVIEW and playing");
				//debug("TABLE:setInterval: REVIEW mode");
				var nextin = getIntime(inextevent).timecodeToNumber();

				if( _cadetMode == CADETMODE_DESCRIPTION ){
					//doStatus("readInitial = ["+readInitial+"]");
					if( !readInitial ){
						//doStatus("triggering initial with ["+getText(getCurrentRow())+"]");
						ttsDo(getText(getCurrentRow()));//responsiveVoice.speak(getText(getCurrentRow()));//,"UK English Female",{rate: 1.5});
						readInitial = true;
						if( getCurrentRow() == (getRowCount()-1) )
							readLast = true;
					}
				}

				if( value >= nextin ){
					setCurrentRow(inextevent);
					setSelectionToHere(_tbodyElement.rows[inextevent].cells[COL_TEXT].firstChild, 0);

					//make sure current row is in view
					scrollToRow(getCurrentRow());
					
					//speak text if in DVS mode
					var texttoread = "";
					var commentrow = false;
					if( nextin == -1 ){
						commentrow = true;
						//doStatus("found comment row at row=["+(getCurrentRow()+1)+"]");
					} else {
						//doStatus("non-comment row at row=["+(getCurrentRow()+1)+"] intime=["+nextin+"]");
						texttoread = getText(getCurrentRow()).trim();
					}
					if( (_cadetMode == CADETMODE_DESCRIPTION) && !readLast && !commentrow ){
						if( inextevent == getRowCount()-1 )
							readLast = true;//don't blast the last one multiple times, otherwise it doesn't get read
						ttsDo(texttoread);//responsiveVoice.speak(texttoread);//,"UK English Female",{rate: 1.5});
						//doStatus("normal just triggered ["+texttoread+"]");
					}
				}
			} else if(_editMode == EDITMODE_TRANSCRIBE && bSpecialPlay){
				if( (currentEndTime > 0) && (value >= currentEndTime) ){
					_editor.cueIntime();
				}
			} else { //just display the current caption or description (but no description text display for fullscreen...)
				
				//return;
			} //all other combinations, for now
			
			
				
			//caption shim for remote players
			if(		(mediaLocationType != MEDIA_LOCATION_LOCAL) 
				||	(mediaLocationType == MEDIA_LOCATION_LOCAL && SR_CAPTIONS_ON) ){ //only for remote media
			
				//debug("TABLE:setInterval: display current target text (caption or description)");
				nextRemoteCaptionIndex = capDisplayedAtTime(PlayerDispatch.playerGetTime());
				
				if( !PlayerDispatch.playerIsPaused()){ //playing
					lastRemotePausedIntime = -1; //goose for next paused
				
					if( nextRemoteCaptionIndex >= 0 ){
				
						nextRemoteHtmlText = getSectionHtml(nextRemoteCaptionIndex);
						nextAlign = getTextAlign(nextRemoteCaptionIndex);
						nextVAlign = getTextVAlign(nextRemoteCaptionIndex);
					
						if(	(nextRemoteCaptionIndex != currentRemoteCaptionIndex)
							|| (nextRemoteHtmlText != currentRemoteHtmlText)
							|| (nextAlign != currentAlign)
							|| (nextVAlign != currentVAlign)
							){
							
							//display the next one
							if(mediaLocationType != MEDIA_LOCATION_LOCAL)
								PlayerDispatch.renderIthCaption(nextRemoteCaptionIndex);
							//debug("TABLE: interval: remotecc: playing: displayed nextindex=["+nextRemoteCaptionIndex+"]");
							
							if(SR_CAPTIONS_ON){ //SR only when playing
								var someevent = new CadetEvent("","","","","");
								someevent = _editor.buildRandomEventStyleRuns(nextRemoteCaptionIndex, someevent)
								var foo;
								foo = someevent.getTextAsText();
								$("#srcaptionsdiv").html(foo);
							}
							
							currentRemoteCaptionIndex = nextRemoteCaptionIndex;	//save the currently displayed index
							currentRemoteHtmlText = nextRemoteHtmlText; //save the currently displayed html
							currentAlign = nextAlign;
							currentVAlign = nextVAlign;
						}
					} else {
						if( ccDisplay )
							ccDisplay.clearCaptions();
					}
				
				} else { //paused
					currentRemoteCaptionIndex = -1; //goose for next playing
					
					var therow = getCurrentRow();
					var thetime = PlayerDispatch.playerGetTime();
					var theplayerrow = capDisplayedAtTime(thetime);
					var theintime = getIntime(therow).timecodeToNumber();
					var theouttime = getOuttime(therow).timecodeToNumber();
					var thehtml = getSectionHtml(therow)
					if( theplayerrow != -1 ){ //== therow) 
					
						nextAlign = getTextAlign(theplayerrow);
						nextVAlign = getTextVAlign(theplayerrow);
						
						if(
							((theintime>=0) && (theintime <= thetime)) 
							&& ((theouttime==-1) || (thetime <= theouttime)) 
							&& ((theintime!=lastRemotePausedIntime)
								|| (theouttime!=lastRemotePausedOuttime)
								|| (thehtml!=lastRemotePausedHTML)
								|| (nextAlign != currentAlign)
								|| (nextVAlign != currentVAlign)
							)
						){
							if(mediaLocationType != MEDIA_LOCATION_LOCAL)
								PlayerDispatch.renderIthCaption(therow);
							//debug("TABLE: interval: remotecc: paused: rendered");
							
							/* not if paused, only if playing
							if(SR_CAPTIONS_ON){ //SR only when playing
								var someevent = new CadetEvent("","","","","");
								someevent = _editor.buildRandomEventStyleRuns(nextRemoteCaptionIndex, someevent)
								var foo;
								foo = someevent.getTextAsText();
								$("#srcaptionsdiv").html(foo);
							}
							*/
							
							lastRemotePausedIntime = theintime;
							lastRemotePausedOuttime = theouttime;
							lastRemotePausedHTML = thehtml;
							currentAlign = nextAlign;
							currentVAlign = nextVAlign;
						}
					} else {// if(theplayerrow != -1){ //&& theplayerrow == -1) { //in between players row
						if( ccDisplay )
							ccDisplay.clearCaptions();
					}
				
				}//if playing or paused
				
			}//only for remote media
			
		}//mediaTimerFunc
			
		
		function setCadetMode(cadetMode){
			_cadetMode = cadetMode;
			makeHeadings(cadetMode);
			if( cadetMode == CADETMODE_DESCRIPTION ){
        		document.getElementById("rbDescription").checked = true;
				$("#ptypeval").text("Description");
        		
				tableShowCol(COL_CUE);
				$("#cuetimediv").show();
				
				//update dialog time if in DVS mode
				updateDialogTime();
			} else{
        		document.getElementById("rbCaption").checked = true;
				$("#ptypeval").text("Caption");
				tableHideCol(COL_CUE);
				$("#cuetimediv").hide();
			}
		}//setTableMode
		
		function makeHeadings(cadetMode){
			//remove existing table header
			//  0   1   2   3      4
			//  #  IN  OUT  CUE  TEXT
			
			if( cadetMode == CADETMODE_DESCRIPTION ){
				$("thead").html("<tr><th class='col0' scope='col'>#</th><th class='col1' scope='col'>START</th><th class='col2' scope='col'>END</th><th class='col3' scope='col'>AUDIO CUE</th><th class='textAlignCenter col4' scope='col'>DESCRIPTION</th></tr>")
			} else{
				$("thead").html("<tr><th class='col0' scope='col'>#</th><th class='col1' scope='col'>START</th><th class='col2' scope='col'>END</th><th class='col3' scope='col'>AUDIO CUE</th><th class='col4 ' scope='col'>CAPTION</th></tr>")
			}
		}//makeHeadings
		function tableHideCol(n){
			//add class "hiden" e.g. "hide0" to hide column 0
			var sfoo = "hide"+n.toString();
			_$tqo.addClass(sfoo);
		}
		function tableShowCol(n){
			//remove class "hiden" e.g. "hide0" to show column 0
			var sfoo = "hide"+n.toString();
			_$tqo.removeClass(sfoo);
		}
		function dialogTime(){
			var sfoo = getText(getCurrentRow());
			var awords;
			var dialogtime = -1;
			if( sfoo.trim().length == 0 ){
				dialogtime = -1;
			} else {
				awords = sfoo.split(" ");
				dialogtime = awords.length / READING_SPEED; //this is minutes (words / words/minute)
				dialogtime = dialogtime * 60; //return seconds, to be formatted
			}
			return dialogtime;
		}//dialogTime
		function textSpeakTime(s){
			var sfoo = s;
			var awords;
			var dialogtime = -1;
			if( sfoo.trim().length == 0 ){
				dialogtime = -1;
			} else {
				awords = sfoo.split(" ");
				dialogtime = awords.length / READING_SPEED; //this is minutes (words / words/minute)
				dialogtime = dialogtime * 60; //return seconds, to be formatted
			}
			return dialogtime;
		}//dialogTime
		function updateDialogTime(){
			if( _cadetMode != CADETMODE_DESCRIPTION ) return;
			var cuetimecolor = "black";
			var pausetime = -1;
			var spausetime = "--";
			var sdialogtime = "--";
			var dialogtime = dialogTime();
			var intime = getIntime(getCurrentRow()).timecodeToNumber();
			var outtime = getOuttime(getCurrentRow()).timecodeToNumber();
			if( dialogtime !=-1 ){
				sdialogtime = dialogtime.toTimecodeAsMinutes();
			}
			if( intime!=-1  && outtime != -1 ){
				pausetime = outtime - intime;
				spausetime = pausetime.toTimecode();
			}
			
			if( pausetime != -1 && dialogtime != -1 && dialogtime > pausetime ){
				$("#cuetime").addClass("alarmcolor");
				$("#cuetime")[0].value = sdialogtime + " / " + spausetime + " \u266A";//" !";
			} else {
				$("#cuetime").removeClass("alarmcolor");
				$("#cuetime")[0].value = sdialogtime + " / " + spausetime;
			}
			
			
		}//updateDialogTime
		
		
		function getRowCount(){
			return(_tbodyElement.rows.length);
		}//getRowCount
		
		
		// NOTE! Calling this INSIDE the corresponding function has weird side-effect, leaving selection spanning a char, etc.
		//		Doing at in .HTML after each styling call seems to work
		function justFocusCaptionCell(){
			_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT].focus();
		}//justFocusCaptionCell

		function focusCurrentRowCaptionCell(){
			focusCaptionCell(getCurrentRow());
		}//focusCurrentRowCaptionCell

		function focusCaptionCell(i){
			if( i<0 ) i=0;
			_tbodyElement.rows[i].cells[COL_TEXT].focus();
			setSelectionCurrentRowToBeginning();
		}//focusCaptionCell
		
		function UIsetProjectFile(s){
			//used to be next to the OpenProject button
			//$("#projectFile").text( s ); 
			
			//browser <title>
			//document.title = "CADET   Project file=["+s+"]";
			$('#localProjectFile').text("Project: "+s);	//set thing next to button
	}
		function UIsetMedia(s){
			//$('#remoteMediaFile').text("");	//clear remote media url
			//debug("TABLE:UIsetMedia: s=["+s+"]");
			var sfoo = ((s.trim().length==0) || (s.trim()=="/")) ? "No Media File" : s;
			$('#localMediaFile').text("Media: "+sfoo);	//set thing next to button
		}
		
		
		function setEditor(ed){
			// instance of an editor that talks to this table
			_editor = ed;
			//PlayerDispatch.setEditor(_editor);//done in editor
		}//setEditor
		
		function setEditMode( mode ){
			if( mode == EDITMODE_TRANSCRIBE )
        		document.getElementById("rbTranscribe").checked = true;
        	else if( mode == EDITMODE_TIME )
        		document.getElementById("rbTime").checked = true;
        	else if( mode == EDITMODE_REVIEW )
        		document.getElementById("rbReview").checked = true;

			_editMode = mode;        	
		}//setEditmode
		
		/////////////////////
		//EVENT HANDLERS
		/////////////////////
		
		/////////////////////
		// keyboard shortcuts
		/////////////////////			
		function windowKeyPressHandler(e){//UNUSED FOR NOW
		}//windowKeyPressHandler
		function windowKeyDownHandler(e){ //Apple meta keys trapped here in Chrome/Firefox (see bottom of function)
			if( _inModal ) { 
				//debug("TABLE:windowKeyDownHandler: NO-RE-ENTRY e.keycode=["+e.keycode+"]"); 
				//e.preventDefault(); //!!!don't prevent defaults
				return;
			}
			//debug("TABLE:windowKeyDownHandler: e.keyCode=["+e.keyCode+"]");
			//SHORTCUT KEYS
			if( ( e.keyCode==32 ) && ( e.ctrlKey )  && ( !e.altKey ) ){
			//playPause	space             control
				//debug("TABLE:windowKeyDownHandler: play/pause");
				if( e.shiftKey ){
					PlayerDispatch.playerPlayPauseSpecial(); //_editor.playPauseSpecial(); //special behavior if DVS mode
				} else {
					PlayerDispatch.playerPlayPause();//_editor.playPauseMedia(); 
				}
				
				e.preventDefault();  
		
			} else if( (e.keyCode==38 ) && ( e.ctrlKey ) ){
			//TEST			left/up/right/down == 37/38/39/40
				//debug("CONTROL-UP-ARROW");
				
				if( e.shiftKey ){
					//doStatus("shift click");
					if( !bMarking ){
						//doStatus("shift click: setting bMarking");
						bMarking = true;
					}
					if( markRow1 < 0 ){	//set first mark if not yet set
						markRow1 = _currentRow;
						//doStatus("shift click: mark1=["+markRow1+"]");
					}
				} else {
					//doStatus("click marking false");
					bMarking = false;
					markRow1 = -1;
					markRow2 = -1;
					unmarkAll();
				}				
				
				
				setCurrentRow(getCurrentRow()-1); 
				setSelectionCurrentRowToEnd();

				if( e.originalEvent.shiftKey ){
					if( bMarking ){
						unmarkAll()
						markRow2 = getCurrentRow();
						//doStatus("shift click: mark2=["+markRow2+"]");
						markRows(markRow1, markRow2);
					}
				}

				e.preventDefault();  
		
			} else if( (e.keyCode==40 ) && ( e.ctrlKey ) ){
			//TEST			left/up/right/down == 37/38/39/40
				//debug("CONTROL-DOWN-ARROW"); 
				
				if( e.shiftKey ){
					//doStatus("shift click");
					if( !bMarking ){
						//doStatus("shift click: setting bMarking");
						bMarking = true;
					}
					if( markRow1 < 0 ){	//set first mark if not yet set
						markRow1 = _currentRow;
						//doStatus("shift click: mark1=["+markRow1+"]");
					}
				} else {
					//doStatus("click marking false");
					bMarking = false;
					markRow1 = -1;
					markRow2 = -1;
					unmarkAll();
				}				
				
				
				setCurrentRow(getCurrentRow()+1); 
				setSelectionCurrentRowToEnd();

				if( e.originalEvent.shiftKey ){
					if( bMarking ){
						unmarkAll()
						markRow2 = getCurrentRow();
						//doStatus("shift click: mark2=["+markRow2+"]");
						markRows(markRow1, markRow2);
					}
				}

				e.preventDefault();  
		
			} else if( (e.keyCode==77 || e.keyCode==109) && ( e.ctrlKey )  && ( e.altKey )&& ( e.shiftKey ) ){
			//STYLE MENU activate	M							control			not alt			shift
			//} else if( (e.keyCode==87 || e.keyCode==119) && ( e.ctrlKey ) && ( !e.shiftKey ) ){
			//STYLE MENU activate	W							control
				//debug("CTRL-SHIFT-ALT-M"); 
				focusMenuBar();
				//$("#FILE_MENU_LINK").focus(); 
				e.preventDefault();  

/*
			} else if( (e.keyCode==77 || e.keyCode==109) && ( e.ctrlKey )  && ( e.altKey )&& ( e.shiftKey ) ){
			//STYLE MENU deactivate	M							control			alt			shift
			//} else if( (e.keyCode==87 || e.keyCode==119) && ( e.ctrlKey ) && ( e.shiftKey ) ){
			//STYLE TABLE activate	W							control			shift
				//debug("CTRL-SHIFT-ALT-M... deactivate menu, back to table current row"); 
				$('li.open').removeClass('open'); //deactivate any open menu items
				//setCurrentRow(getCurrentRow()); 
				setSelectionCurrentRowToEnd();
				e.preventDefault();  
*/

			} else if( (e.keyCode==82 || e.keyCode==114) && ( e.ctrlKey )  && ( e.shiftKey ) ){
			//RULER toggle			R							control			shift
				//debug("CTRL-SHIFT-R... toggle ruler"); 
				_editor.showHideRuler(!RULER_SHOWING);
				e.preventDefault();  


/**/
			} else if( (e.keyCode==219) && ( e.ctrlKey )  ){
			//SPEED SLOWER			-			control			shift
				_editor.bumpPlayerSpeed(SLOWER); 
				e.preventDefault();
			} else if( (e.keyCode==221) && ( e.ctrlKey )  ){
			//SPEED FASTER			+			control			shift
				_editor.bumpPlayerSpeed(FASTER); 
				e.preventDefault();
			} else if( (e.keyCode==220) && ( e.ctrlKey )  ){
			//SPEED NORMAL			0			control			shift
				_editor.setPlayerSpeedNormal(1.0); 
				e.preventDefault();				
				
				
			} else if( (e.keyCode==88 || e.keyCode==120) && ( e.ctrlKey )  && ( e.shiftKey ) ){
			//EDIT CUT BLOCK		X  or			x			control			shift
				_editor.blockCut(); 
				e.preventDefault();
			} else if( (e.keyCode==67 || e.keyCode==99) && ( e.ctrlKey )  && ( e.shiftKey ) ){
			//EDIT COPY BLOCK		C  or			c			control			shift
				_editor.blockCopy(); 
				e.preventDefault();
			} else if( (e.keyCode==86 || e.keyCode==118) && ( e.ctrlKey )  && ( e.shiftKey ) ){
			//EDIT PASTE BLOCK		V  or			v			control			shift
				_editor.blockPaste(); 
				e.preventDefault();
			} else if( (e.keyCode==8 || e.keyCode==46) && ( e.ctrlKey )  && ( e.shiftKey ) && ( !e.altKey ) ){
			//EDIT DELETE SEL	BackDel  or	 ForwardDel		control			    shift			NOT ALT
				_editor.deleteEvent(); 
				e.preventDefault();
				
			} else if( (e.keyCode==8) && ( e.ctrlKey )  && ( e.shiftKey ) && ( e.altKey ) ){
			//EVENTS COMBINE UP	BackDel		control			    shift			alt
				_editor.combineRowWithPreviousRow(); 
				e.preventDefault();
				
			} else if( (e.keyCode==70 || e.keyCode==102 ) && ( e.ctrlKey ) && ( !e.shiftKey )&& ( !e.altKey ) ){
			//find 					F		    	f				control
				_editor.editFind();
				e.preventDefault();
				
			} else if( (e.keyCode==70 || e.keyCode==102 ) && ( e.ctrlKey ) && ( e.shiftKey )&& ( e.altKey ) ){
			//fooTest				F		    	f			control				shift			alt
				debug("TABLE shortcuts: calling _editor.fooTest()");
				e.preventDefault();
			
		
			} else if( (e.keyCode==74 || e.keyCode==106) && ( e.ctrlKey ) ){
			//NEW PROJECT			J  or			j			control
				_editor.tryNewProject(); 
				e.preventDefault();  
		
			} else if( (e.keyCode==77 || e.keyCode==109) && ( e.ctrlKey )  && ( !e.altKey )&& ( !e.shiftKey ) ){
			//OPENMEDIA			 m       	   					control
				_editor.openMediaFile(); 
				e.preventDefault();  
		
			} else if( (e.keyCode==77 || e.keyCode==109) && ( e.ctrlKey )  && ( !e.altKey ) && ( e.shiftKey ) ){
			//OPENMEDIAURL			M  		      	      		control
				_editor.openMediaUrl(); 
				e.preventDefault();  
		
			} else if( (e.keyCode==68 || e.keyCode==100) && ( e.ctrlKey ) ){
			//CADETMODE TOGGLE		D  or d       	      		control
				_editor.toggleCadetMode(); 
				e.preventDefault();  
		
			} else if( (e.keyCode==69 || e.keyCode==101) && ( e.ctrlKey ) ){
			//EDITMODE TOGGLE		E  or E       	      		control
				_editor.toggleEditMode(); 
				e.preventDefault();  
			
			} else if( (e.keyCode==66 || e.keyCode==98) && ( e.ctrlKey ) ){
			//BOLD					B or b       	     control
				//debug("TABLE:windowKeyDownHandler makeBold");
				_editor.makeBold(true); 
				e.preventDefault();  
			
			} else if( (e.keyCode==73 || e.keyCode==105) && ( e.ctrlKey ) ){
			//ITALIC				I or i		control
				_editor.makeItalic(true); 
				e.preventDefault();  
			
			} else if( (e.keyCode==85 || e.keyCode==117) && ( e.ctrlKey ) ){
			//UNDERLINE				U or u		control
				_editor.makeUnderline(true); 
				e.preventDefault();  
			
			///// JUMP		
			} else if( (e.keyCode==71) && ( e.ctrlKey && !e.shiftKey && !e.altKey ) ){
			//REV TINY				g  		control			NOshift		NOalt/option
				//debug("keyboard: g gump back tiny");
				PlayerDispatch.mediaJump(false, JUMP_TINY); 
				e.preventDefault();  
			} else if( (e.keyCode==71) && ( e.ctrlKey && e.shiftKey && !e.altKey ) ){
			//REV SMALL				g  		control			shift		NOalt/option
				//debug("keyboard: g gump back small");
				PlayerDispatch.mediaJump(false, JUMP_SMALL); 
				e.preventDefault();  
			} else if( (e.keyCode==71) && ( e.ctrlKey && e.shiftKey && e.altKey ) ){
			//REV LARGE				G  		control			shift		alt/option
				//debug("keyboard: G gump back large");
				PlayerDispatch.mediaJump(false, JUMP_LARGE); 
				e.preventDefault();  
			} else if( (e.keyCode==72) && ( e.ctrlKey && !e.shiftKey && !e.altKey ) ){
			//FWD TINY				h  		control			NOshift		NOalt/option
				//debug("keyboard: g gump fwd tiny");
				PlayerDispatch.mediaJump(true, JUMP_TINY); 
				e.preventDefault();  
			} else if( (e.keyCode==72) && ( e.ctrlKey && e.shiftKey && !e.altKey ) ){
			//FWD SMALL				h  		control			shift		NOalt/option
				//debug("keyboard: h gump fwd small");
				PlayerDispatch.mediaJump(true, JUMP_SMALL); 
				e.preventDefault();  
			} else if( (e.keyCode==72) && ( e.ctrlKey && e.shiftKey && e.altKey ) ){
			//FWD LARGE				H  		control			shift		alt/option
				//debug("keyboard: H gump fwd large");
				PlayerDispatch.mediaJump(true, JUMP_LARGE); 
				e.preventDefault();  
		
			} else if( ( e.keyCode==188 ) && e.ctrlKey ){
			//INTIME				,      		control
				_editor.setIntime();   
				e.preventDefault();  
					
			} else if( (e.keyCode==190 ) && e.ctrlKey ){
			//OUTTIME				.      		control
				_editor.setOuttime(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==81 || e.keyCode==113) && ( e.ctrlKey && !e.shiftKey ) ){
			//CUEIN					Q  or q       	      		control
				PlayerDispatch.cueMedia(getIntime(_currentRow).timecodeToNumber()); //_editor.cueIntime(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==81 || e.keyCode==113) && ( e.ctrlKey && e.shiftKey ) ){
			//CUEOUT				Q  or q       	      		control
				PlayerDispatch.cueMedia(getOuttime(_currentRow).timecodeToNumber()); //_editor.cueOuttime(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==89 || e.keyCode==121) && ( e.ctrlKey && !e.shiftKey ) ){
			//PLAYHEAD-MATCH		Y  or y       	      		control
				_editor.syncToPlayhead(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==79 || e.keyCode==199 ) && ( e.ctrlKey ) ){
			//OPEN PROJECT			O		    	o				control
				//debug("keyboard open project");
				_editor.tryOpenProject(); 
				e.preventDefault();  
				
			} else if( (e.keyCode==76 || e.keyCode==108 ) && ( e.ctrlKey ) ){
			//INSERT musicaL NOTE	L		    	l				control
				_editor.insertMusicalNote();
				e.preventDefault();
					
			} else if( (e.keyCode==83 || e.keyCode==115 ) && ( e.ctrlKey )  && ( !e.altKey ) ){
			//SAVE		S		    	s				control
				//debug("keyboard save");
				_editor.doSaveProject(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==83 || e.keyCode==115 ) && ( e.ctrlKey )  && ( e.altKey ) ){
			//STOP		S		    	s					control				altKey
			//Stop player/rewind to zero
				_editor.doPlayerStop(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==78 || e.keyCode==110 ) && ( e.ctrlKey )  && ( !e.shiftKey )  && ( !e.altKey ) ){
			//PRESENTATION			N		    	n			control			not shift			not alt
				_editor.kioskMode(); 
				e.preventDefault();  
					
			} else if( (e.keyCode==78 || e.keyCode==110 ) && ( e.ctrlKey )  && ( e.shiftKey )  && ( !e.altKey ) ){
			//PRESENTATION			N		    	n			control			not alt				not shift
			// without captions (false)
				_editor.kioskMode(false); 
				e.preventDefault();  
					
			} else if( (e.keyCode==75 || e.keyCode==107 ) && ( e.ctrlKey ) ){
			//KEY SHORTCUTS		K		    	k				control
				_editor.showKeyboard(); 
				//showShortcutsModeless("/-cad3t-/help-shortcuts.html");
				//e.preventDefault();  
				e.preventDefault ? e.preventDefault() : (e.returnValue = false);
					
			} else if( (e.keyCode == 112 && e.charCode==0) ){
			//HELP SHORTCUTS			F1
				showHelp(); 
				e.preventDefault ? e.preventDefault() : (e.returnValue = false);
				//e.preventDefault(); //for all others
				//e.returnValue = false; //for IE
			/**/		
			} else if( (e.keyCode==80 || e.keyCode==112) && ( e.ctrlKey && e.shiftKey ) ){
				;   //alert("control shift p");
				//e.preventDefault();  
					
			} else if( e.originalEvent.metaKey || e.originalEvent.ctrlKey ){ //apple key Chrome/Firefox trapped here
				if(	e.originalEvent.which==86 ){//apple-v paste on Chrome/Firefox
					_editor.makeDirty(true);
					//reformatRow(getCurrentRow());//doesn't work here, the value hasn't been pasted
				}
				//debug("TABLE:windowKeyDownHandler: NO-MATCH e.keycode=["+e.keycode+"]");
				return;
			}

//		showFileBrowserModal(DLG_MODE_OPEN, DISPATCH_OPEN_MEDIA, cadet.openMediaFromFile);


		} //windowKeyDownHandler
		
		var menuBarIsFocused = false;
		function focusMenuBar(){
			//debug("document.activeElement.parentElement.localName=["+document.activeElement.parentElement.localName+"]")
			if( document.activeElement.parentElement.localName == "td" )
				menuBarIsFocused = false;
			else
				menuBarIsFocused = true;
				
			if( menuBarIsFocused ){
				//close the menubar and refocus the current row
				$('li.open').removeClass('open'); //deactivate any open menu items
				setSelectionCurrentRowToEnd();
				menuBarIsFocused = false;
			} else {
				//focus the menuBar
				$("#FILE_MENU_LINK").focus(); 
				menuBarIsFocused = true;
			}
		}//focusMenuBar


		function reformatRow(i){
			var nfoo = getIntime(i);
			doStatus("intime=["+nfoo+"]");
		}//reformatRow

		//////////////////////////////////////////////////
		// START for grabbing content from cursor to end
		//////////////////////////////////////////////////
		function getBlockContainer(node) {
			while (node) {
				//if (node.nodeType == 1 && /^(P|H[1-6]|DIV)$/i.test(node.nodeName)) {
				if (node.nodeType == 1 && /^(P|H[1-6]|SECTION)$/i.test(node.nodeName)) {
					//debug("TABLE:getBlockContainer: node.nodeName=["+node.nodeName+"]");
					return node;
				}
				//if(node.parentNode.className != "content-column" ){
				//	return node;
				//}
				node = node.parentNode;
			}
		}//getBlockContainer
	
		function extractBlockContentsFromCaret() {
		if (typeof window.getSelection != "undefined" && typeof document.createRange != "undefined") {		
				var sel = window.getSelection();
				if (sel.rangeCount) {
					var selRange = sel.getRangeAt(0);
					var blockEl = getBlockContainer(selRange.endContainer);
					if (blockEl) {
						var range = selRange.cloneRange();
						range.selectNodeContents($(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT], "section")[0]);
						range.setStart(selRange.endContainer, selRange.endOffset);
						//return range.extractContents();
						var stuff = range.extractContents();
						//range.collapse();
						//sel.removeAllRanges();
						return stuff;
					}
				}

			} else if (typeof document.body.createTextRange != "undefined") {
				debug("TABLE:extractBlockContentsFromCaret: not implemented");
			}
		}//extractBlockContentsFromCaret
		/*
		function extractBlockContentsFromCaretOld() {
			var sel = window.getSelection();
			if (sel.rangeCount) {
				var selRange = sel.getRangeAt(0);
				var blockEl = getBlockContainer(selRange.endContainer);
				if (blockEl) {
					var range = selRange.cloneRange();
					range.selectNodeContents(blockEl);
					range.setStart(selRange.endContainer, selRange.endOffset);
					//return range.extractContents();
					var stuff = range.extractContents();
					range.collapse();
					sel.removeAllRanges();
					return stuff;
				}
			}
		}//extractBlockContentsFromCaretOld
		*/
		function extractBlockContentsToCaret() {
		
		if (typeof window.getSelection != "undefined" && typeof document.createRange != "undefined") {		
				var sel = window.getSelection();
				if (sel.rangeCount) {
					var selRange = sel.getRangeAt(0);
					var blockEl = getBlockContainer(selRange.startContainer);
					if (blockEl) {
						var range = selRange.cloneRange();
						range.selectNodeContents($(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT], "section")[0]);
						var foo=$(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT])[0];
						range.setEnd(selRange.endContainer, selRange.endOffset);
						var stuff = range.extractContents();
						return stuff;

					}
				}
			
			} else if (typeof document.body.createTextRange != "undefined") {
				debug("TABLE:extractBlockContentsToCaret: not implemented");
			}
		}//extractBlockContentsToCaret
		/*
		function extractBlockContentsToCaretOld() {
			var sel = window.getSelection();
			if (sel.rangeCount) {
				var selRange = sel.getRangeAt(0);
				var blockEl = getBlockContainer(selRange.startContainer);
				if (blockEl) {
					var range = selRange.cloneRange();
					range.selectNodeContents(blockEl);
					//range.setStart(selRange.startContainer, selRange.startOffset);
					var foo=$(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT])[0];
					range.setStart($(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT])[0].firstChild.firstChild, 0);//the SECTION
					range.setEnd(selRange.startContainer, selRange.startOffset);
					//return range.extractContents();
					var stuff = range.extractContents();
					//range.collapse();
					//sel.removeAllRanges();
					return stuff;

				}
			}
		}//extractBlockContentsToCaretOld
		*/
		function checkForMoreText() {//currently unused
			var sel = window.getSelection();
			if (sel.rangeCount) {
				//debug("TABLE:checkForMoreText: sel.rangeCount exists");
				var selRange = sel.getRangeAt(0);
				var blockEl = getBlockContainer(selRange.endContainer);
				if (blockEl) {
					var range = selRange.cloneRange();
					range.selectNodeContents(blockEl);
					range.setStart(selRange.endContainer, selRange.endOffset);
					//debug("TABLE:checkForMoreText: blockEl exists");
					//return true;
				}
			}
			
		}//checkForMoreText
		//////////////////////////////////////////////////
		// END for grabbing content from cursor to end
		//////////////////////////////////////////////////
		
		function keyUpHandler(i, e){
			if( _inContentColumn ){
			}
		}//keyUpHandler
		
		function keyDownHandler(i, e){
			//return;
			//debug("TABLE:keyDownHandler: keycode=["+e.keyCode+"] inContentColumn=["+_inContentColumn+"]");
			
			if( !_inContentColumn ){
				//debug("TABLE:keyDownHandler: not in content column e.keyCode=["+e.keyCode+"]");
				//         colon           period              between 0 and 9
				if( (e.keyCode==58) || (e.keyCode==46) || (e.keyCode>=48 && e.keyCode<=57) ){
					DIRTY = true;
					_editor.makeDirty(true);
					return true;
				} else if( e.originalEvent.metaKey ){ //apple key
					if(	e.keyCode==118 ) //apple-v paste
						_editor.makeDirty(true);
					return;
				} else {
					e.preventDefault();
					return false;
				}
			}
			
			if( e.keyCode == 13 ){
				DIRTY = true;
				_editor.makeDirty(true);
				if( _returnPending ){	//double-return double return opens a new caption moving downstream text to the new row
					//do something awesome here
					//debug("double-return detected");
					//figure out how to delete the extra return....
					
					var oldtext = getText(_currentRow).trim();
					
					//cut from here to end to clipboard
					var stuff = extractBlockContentsFromCaret();
					//debug("stuff to end=["+stuff.textContent+"]");
					var newtext = stuff.textContent.trim();
					
					//remove any empty <p> tag (IE leaves these)
					$("td > div > p").last().filter(function(){
						//alert("this.textContent=["+this.textContent+"]");
						return $.trim(this.textContent).trim().length == 0
					}).remove();
					//remove any empty <div> tag (safari/webkit leaves these)
					$("section > div").last().filter(function(){
						//alert("this.textContent=["+this.textContent+"]");
						return $.trim(this.textContent).trim().length == 0
					}).remove();
					
					//add a new row after this one
					//addRowAt(_currentRow+1, HIDDEN_TIME, HIDDEN_TIME, stuff.textContent);//could be in the middle so disguise timecodes
					/*NEW
					if( stuff.textContent.trim().length==0 ){
						addRowAt(_currentRow+1, HIDDEN_TIME, HIDDEN_TIME, "");//could be in the middle so disguise timecodes
					} else {
						addRowAt(_currentRow+1, ZEROS, INFINITY, stuff.textContent);//could be in the middle so disguise timecodes
					}
					*/
					
					if( !DOUBLE_CR_ESTIMATES_INTIME ){
						if( stuff.textContent.trim().length==0 ){
							addRowAt(_currentRow+1, "", "", newtext);//could be in the middle so disguise timecodes
						} else {
							addRowAt(_currentRow+1, "", "", newtext);//could be in the middle so disguise timecodes
						}
					} else {
						// create the new row, and jigger the times depending on in/out times
						var oldintime = getIntime(getCurrentRow()).timecodeToNumber();
						var oldouttime = getOuttime(getCurrentRow()).timecodeToNumber();
					
						if( oldintime == -1 ){ //no intime so no times for new row
							addRowAt(_currentRow+1, "", "", newtext);//could be in the middle so disguise timecodes
						
						} else { //there's an intime, so figure out in/out of new row
					
							if( oldouttime == -1 ){ //intime but no outtime, then blank it, set new intime to half the distance and transfer it to new caption
								addRowAt(_currentRow+1, "", "", newtext);//could be in the middle so disguise timecodes
							
							} else { //intime and outtime, blank current outtime, then  set in/out for new row
								//this is the interesting case; proportion the on-screen time of the new row based on text length
								setOuttime(getCurrentRow(), -1);
								var newintime = oldintime + ((oldouttime-oldintime)*(1-(newtext.length/oldtext.length)));
								var newouttime = oldouttime;
								addRowAt(_currentRow+1, newintime.toTimecode(), newouttime.toTimecode(), newtext);//could be in the middle so disguise timecodes
							}
						
						}
					}
					
					//addRowAt(_currentRow+1, HIDDEN_TIME, HIDDEN_TIME, stuff.textContent);//could be in the middle so disguise timecodes
					////addRowAt(_currentRow+1, getMediaTime().toTimecode(), INFINITY, stuff.textContent);//could be in the middle so disguise timecodes
					
					//cue up the intime of the newly created row
					setTimeout(function() { cueIntime(_currentRow) }, 200);	
										
					//reset the trigger
					_returnPending = false;	//reset the boolean
					//debug("keyDownHandler: second return key added row:  _returnPending=["+_returnPending+"]");
					e.preventDefault();	//suppress the return spilling into the new row
				} else {
					/*
					//if at very end, add a space and then backup to before the space before adding next row
					var stuff = extractBlockContentsFromCaret();
					debug("TABLE:keyDownHandler: first return: stuff.textContent.length=["+stuff.textContent.length+"]");
					if( stuff.textContent.length == 0 ){
						debug("TABLE:keyDownHandler: first return: nothing to the right of cursor");
						//append a space
						insertCurrentRowSelectionText(" ");
						//move cursor back one character to leave extra space
						moveCaret(window, -1);
					}
					
					var sel = window.getSelection();
					var stuff = sel.focusNode;
					debug("TABLE:keyDownHandler: first return: focusNode.textContent.length=["+stuff.textContent.length+"]");
					
					insertNewline();
					e.preventDefault();
					*/
					
					//make sure that there's nothing but blank to the right of the current selection
					//checkForMoreText();
					//debug("stuff to end=["+stuff.textContent+"]");

					//document.execCommand('insertHTML', false, '<br /><br />');
					//e.preventDefault();
					_returnPending = true;	//first of a potential double-return
					//debug("keyDownHandler: first return key:  _returnPending=["+_returnPending+"]");
					
				}
			} else {
				if( !e.ctrlKey && !e.shiftKey && !e.metaKey && !e.altKey ) { //ignore plain modifiers
					DIRTY = true; //actually did something
					_editor.makeDirty(true);
				}
				_returnPending = false;	//reset the boolean
				//debug("keyDownHandler: regular key:  _returnPending=["+_returnPending+"]");
			}
			
		}//keyDownHandler
		
		function keyPressHandler(e){ //called by Safari for meta (apple) key events
			//debug("TABLE:keyPressHandler: which=["+e.which+"] inContentColumn=["+_inContentColumn+"]");
			
			/////////////////////
			// straight text entry to cells
			/////////////////////
			
			if( !_inContentColumn ){
				//debug("TABLE:keyPressHandler: not in content column e.keyCode=["+e.keyCode+"]");
				//   tab ??            backspace       period           between 0 and 9
				if( (e.which==0) || (e.which==8) || (e.which==58) || (e.which==46) || (e.which>=48 && e.which<=57) ){
					_editor.toggleAutoRefreshCaptions(true);
					DIRTY = true;
					_editor.makeDirty(true);
					//_editor.refreshCaptions();
					return;
				} else if( e.originalEvent.metaKey || e.originalEvent.ctrlKey ){ //apple key
					if(	e.originalEvent.which==118 ) //apple-v paste on Safari
						_editor.makeDirty(true);
					return;
				} else {
					//if( !e.originalEvent.metaKey )	//allow all metakeys from Mac through
						e.preventDefault();
					//else
					//	_editor.makeDirty(true);
				}
			} else {
				_editor.makeDirty(true);
			}
						
		}//keyPressHandler
		
		function focusOutHandler(e){
			//debug("TABLE:focusOutHandler: event=["+e+"]");
			
			//reformat the timecode in the relatedTarget element
						
		}//keyDownHandler
		
		
		//////////////////
		
		function combineRowWithPreviousRow(){
			if( _currentRow == 0 ) //at top, do nothing
				return;
				
			//combine current row with previous row (UP), deleting current row and moving outtime if it exists
			var bottomrow = _currentRow;
			var bottomtext = getText(_currentRow).trim();
			var bottomin = getIntime(getCurrentRow()).timecodeToNumber();
			var bottomout = getOuttime(getCurrentRow()).timecodeToNumber();
			
			setCurrentRow(bottomrow-1);
			
			//add bottom text to end of top text , appending space between
			setSelectionCurrentRowToEnd(_currentRow);
			document.execCommand("insertHTML", false, " " + bottomtext);
			
			//replace outtime with bottomout
			if( bottomout != -1 )
				setOuttime(_currentRow, bottomout);
						
			//delete the old event
			deleteSomeEvent(bottomrow);
		}//combineRowWithPreviousRow
		
		
		function getSelectedText() {
            if (window.getSelection) {
                return window.getSelection();
            }
            else if (document.getSelection) {
                return document.getSelection();
            }
            else {
                var selection = document.selection && document.selection.createRange();
                if (selection.text) {
                	debug("TABLE: getSelectedText: last else");
                    return selection.text;
                }
                return false;
            }
            return false;
        };
        
        function setSelectionToBeginning( el ){
			var range = document.createRange();
			var sel = window.getSelection();
			range.setStart(el, 0);
			range.collapse(true);
			sel.removeAllRanges();
			sel.addRange(range);
        }//setSelectionToBeginning
        function setSelectionCurrentRowToBeginning(){
        	if( RULER_SHOWING )
        		var el = _tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild.nextSibling;
        	else
        		var el = _tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild;
			var range = document.createRange();
			var sel = window.getSelection();
			range.setStart(el, 0);
			range.collapse(true);
			sel.removeAllRanges();
			sel.addRange(range);
        }//setSelectionCurrentRowToBeginning
        function setSelectionCurrentRowToEnd() {//placeCaretAtEnd(el) {
        	if( RULER_SHOWING )
        		var el = _tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild.nextSibling;
        	else
        		var el = _tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild;
        	
        	
			//el.focus();
			if (typeof window.getSelection != "undefined"
					&& typeof document.createRange != "undefined") {
				//debug("TABLE:setSelectionCurrentRowToEnd: getSelection and  createRange defined");
				var range = document.createRange();
				range.selectNodeContents(el);
				range.collapse(false);
				var sel = window.getSelection();
				sel.removeAllRanges();
				sel.addRange(range);
			} else if (typeof document.body.createTextRange != "undefined") {
				//debug("TABLE:setSelectionCurrentRowToEnd: createTextRanged defined");
				var textRange = document.body.createTextRange();
				textRange.moveToElementText(el);
				textRange.collapse(false);
				textRange.select();
			}
		}//setSelectionCurrentRowToEnd
		function insertCurrentRowSelectionText(text) {
			var sel, range;
			if (window.getSelection) {
				sel = window.getSelection();
				if (sel.rangeCount) {
					range = sel.getRangeAt(0);
					range.deleteContents();
					range.insertNode(document.createTextNode(text));
				}
			} else if (document.selection && document.selection.createRange) {
				range = document.selection.createRange();
				range.text = text;
			}
			
			//leave the just-inserted text selected so that it can be subsequently styled
			selectToEndOfText();
			
		} //insertCurrentRowSelectionText
		
		function insertMusicalNote() {
			//debug("TABLE:insertMusicalNote: trying to insert &#9834 \u266A");
			//moveCaret(window, 1);
			//return;
			
			//If menu is clicked alone, the focus strays from the contenteditable and nothing will happen here...
			//this doesn't work.... _selPoint;//.focus();
			//this doesn't work.... $(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT]).focus();
			document.execCommand("insertHTML", false, "\u266A");
			return;
			
		} //insertMusicalNote
		
		function selectToEndOfText() {
			var sel = window.getSelection();
			if (sel.rangeCount) {
				var selRange = sel.getRangeAt(0);
				var blockEl = getBlockContainer(selRange.endContainer);
				if (blockEl) {
					var range = selRange.cloneRange();
					range.selectNodeContents(blockEl);
					range.setStart(selRange.endContainer, selRange.endOffset);

					sel.removeAllRanges();
					sel.addRange(range);					
				}
			}
		}//selectToEndOfText
		function insertCurrentRowSelectionTextOLD(text) {
			var sel, range, html;
			if (window.getSelection) {
				sel = window.getSelection();
				if (sel.getRangeAt && sel.rangeCount) {
					range = sel.getRangeAt(0);
					range.deleteContents();
					range.insertNode( document.createTextNode(text) );
				}
			} else if (document.selection && document.selection.createRange) {
				document.selection.createRange().text = text;
			}
		} //insertCurrentRowSelectionTextOLD
        function setSelectionToHere(el, iwhere ){
			var range = document.createRange();
			var sel = window.getSelection();
			//range.setStart(el, iwhere);
			range.setStart(el, 0);
			range.collapse(true);
			sel.removeAllRanges();
			sel.addRange(range);
        }//setSelectionToHere

		function moveCaret(win, charCount) {
			var sel, range;
			if (win.getSelection) {
				// IE9+ and other browsers
				sel = win.getSelection();
				if( sel.isCollapsed ){
				}
				if (sel.rangeCount > 0) {
					var textNode = sel.focusNode;
					var newOffset = sel.focusOffset + charCount;
					sel.baseOffset +=1;
					sel.collapse(textNode, Math.min(textNode.length, newOffset));
				}
			} else if ( (sel = win.document.selection) ) {
				// IE <= 8
				if (sel.type != "Control") {
					range = sel.createRange();
					range.move("character", charCount);
					range.select();
				}
			}
		}

        function insertNewline(){
        	//first add a space to the end of the row
			//setSelectionCurrentRowToEnd();
			insertCurrentRowSelectionText(" ");
			//setSelectionCurrentRowToEnd();
			//now move cursor left
			moveCaret(window, -1);
			
			if(getSelection().modify) {     /* chrome */
				var selection = window.getSelection(),
				range = selection.getRangeAt(0),
				br = document.createElement('br');
				endingspace = document.createTextNode(' ');
				range.deleteContents();
				//range.insertNode(br);
				//range.insertNode(endingspace);
				range.insertNode(br);
				range.setStartAfter(br);
				range.setEndAfter(br);
				range.collapse(false);
				selection.removeAllRanges();
				selection.addRange(range);       /* end chrome */
			} else {
				document.createTextNode('\n');    /* internet explorer */
				var range = getSelection().getRangeAt(0);
				range.surroundContents(newline);
				range.selectNode(newline.nextSibling);   /* end Internet Explorer 11 */
			}
        }//insertNewline
        
		function selectAll(el) {
			var range = document.createRange();
			range.selectNodeContents(el);
			var sel = window.getSelection();
			sel.removeAllRanges();
			sel.addRange(range);
			el.focus()
		}
		
		function clearSelection(){
			window.getSelection().removeAllRanges();
		}
		
		function newProject(){
			//debug("TABLE:newProject: enter");
			clearAndLeaveSingle();
			showHideRuler(false);
		}//newProject
		
		function unsetupMediaPlayerLocal(){
				$("#cadetvideo")[0].src=""; 
				var trk=$("#cadetvideo > track")[0];
				trk.src="";
				$("#cadetplayerLocal").css("display","none");	//hide local player
				return;
		}//unsetupMediaPlayerLocal
		function setupMediaPlayer(sport, sdir, sfile){
			
			if( sfile.length == 0 ){
				$("#cadetvideo").html('<track src="" kind="captions" srclang="en" default="true"/> Your browser does not support the video tag.');
				$("#cadetvideo")[0].src=""; 
				return;
			}		
		
		
			//adjust track file name
			var ttname;
			ttname = sfile.replace(/#/g,"%23").substring(0,sfile.lastIndexOf(".")) + ".temp.vtt";
			//_trackFilename = ttname;
			
			//set up the player html
			var mediaUrl = "http://localhost:"+sport+sdir.replace(/#/g,"%23")+"/"+sfile.replace(/#/g,"%23");//encode hash sign
			//debug("TABLE: setupMediaPlayer: mediaUrl=["+mediaUrl+"]");
			$("#cadetvideo")[0].src=mediaUrl; 
			var trk=$("#cadetvideo > track")[0];
			var trackUrl = "http://localhost:"+sport+sdir.replace(/#/g,"%23")+"/"+ttname
			//debug("TABLE: setupMediaPlayer: trackUrl=["+trackUrl+"]");
			trk.src=trackUrl;
			
			//UI mediaUrl
			UIsetMedia(_webroot.replace(/\/+$/, "") + sdir+"/"+sfile);
		}//setupMediaPlayer

        function getHtmlText(r){
        	return( _tbodyElement.rows[r].cells[COL_TEXT].innerHTML );
        }//getHtmlText
        function getSectionHtml(r){
        	return( r>=0 ? _tbodyElement.rows[r].cells[COL_TEXT].firstChild.innerHTML : "" );
        }//getSectionHtml
		function setHtmlText(r,s) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			//_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = s;
			_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = s;
		}//setHtmlText
		function setSectionHtml(r,s) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			//_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = s;
			_tbodyElement.rows[r].cells[COL_TEXT].firstChild.innerHTML = s;
		}//setSectionHtml
		function setCellHtml(r,s) {
			//debug("TABLE:setCellHtml row=["+r+"] val=["+s+"]");
			_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = s;
		}//setCellHtml
		
		function syncToTime(ntargettime){
			var ntableintime, ntableouttime, i=-1;
			var possible = -1;//BCB!!! was 0
			//ntabletime = getOuttime(0).timecodeToNumber();
			//start from the top, binary search  for ntargettime <= ntableTime
			//while(ntargetime > ntabletime){
			//}
			for( i=0; i<_tbodyElement.rows.length; i++ ){
				ntableintime = getIntime(i).timecodeToNumber();
				ntableouttime = getOuttime(i).timecodeToNumber();
				if( (ntableintime == -1) && (ntableouttime == -1) ) //skip untimed rows altogether
					continue;
				if( ntableouttime == -1 ){ //only intime specified
					if( ntargettime >= ntableintime ){//found a possible
						possible = i;//return(i);
					} else { //should never get here... we've gone past it
						return( possible );
					}
				} else { //both in and out times specified
					if( (ntargettime >= ntableintime) && (ntargettime <= ntableouttime)){//found a possible
						possible = i;//return(i);
					} else if(ntargettime > ntableouttime){
						possible = i;
					}
				}
			}
			//return(i);
			return(possible);
		}//syncToTime
		
		/*****************
			capDisplayedAtTime is similar to SyncToTime, but returns -1 if it's outside of display
		*****************/
		function capDisplayedAtTime(ntargettime){
			var ntableintime, ntableouttime, i=-1;
			var possible = -1;//BCB!!! was 0
			//ntabletime = getOuttime(0).timecodeToNumber();
			//start from the top, binary search  for ntargettime <= ntableTime
			//while(ntargetime > ntabletime){
			//}
			for( i=0; i<_tbodyElement.rows.length; i++ ){
				ntableintime = getIntime(i).timecodeToNumber();
				ntableouttime = getOuttime(i).timecodeToNumber();
				if( (ntableintime == -1) && (ntableouttime == -1) ) //skip untimed rows altogether
					continue;
				if( ntableouttime == -1 ){ //only intime specified
					if( ntargettime >= ntableintime ){//found a possible
						possible = i;//return(i);
					} else { //should never get here... we've gone past it
						return( possible );
					}
				} else { //both in and out times specified
					if( (ntargettime >= ntableintime) && (ntargettime <= ntableouttime)){//found a possible
						possible = i;//return(i);
					} else if(ntargettime > ntableouttime){
						possible = -1;
					}
				}
			}
			//return(i);
			return(possible);
		}//syncToTime
		
		function getIntime(iwhich){
			return( _tbodyElement.rows[iwhich].cells[COL_IN].textContent );
		}//getIntime
		function playerIsPaused(){
			var ret = true;//defaults to true, in case there's no media loaded
			
			//now handled canonically via PlayerDispatch
			if( PlayerDispatch.playerIsPaused() )
				return true;
			else
				return false;
				
			return;
			
			// OLD WAY *****************************
			var myVideo = $("#cadetvideo")[0];
				if( myVideo.paused ){
					ret = true;
				} else {
					ret = false; 
				}
			return ret;
			// ******************************
		}//playerIsPaused
		function setIntime(iwhich, ntime){
			//debug("TABLE: setIntime which=["+iwhich+"] time=["+ntime.toTimecode()+"]");
			if( iwhich > 0 ){	//trap previous outtime and blink
				var soldintime = _tbodyElement.rows[iwhich].cells[COL_IN].firstChild.textContent;
				var noldintime = soldintime.timecodeToNumber();
				var soldprevouttime = _tbodyElement.rows[iwhich-1].cells[COL_OUT].firstChild.textContent;
				var noldprevouttime = soldprevouttime.timecodeToNumber();
				var noldblinktime = Math.abs(noldintime - noldprevouttime);
				//debug("soldprevouttime=["+soldprevouttime+"] noldblinktime=["+noldblinktime+"]");
			}
				
			DIRTY = true;
			_editor.makeDirty(true);
			_tbodyElement.rows[iwhich].cells[1].firstChild.textContent = ntime.toTimecode();
			
			/*
			//if in timing mode, maybe set previous outtime and then skip to next caption
			if( !playerIsPaused() ){ // if playing....  //if( _editMode == EDITMODE_TIME ){
			
				//set previous outtime to this intime - MIN_BLINK_TIME
				if( iwhich > 0 ){
					_tbodyElement.rows[iwhich-1].cells[2].firstChild.textContent = (ntime-MIN_BLINK_TIME).toTimecode();
				}
			
				//go to next row
				setCurrentRow(_currentRow+1);
				//debug("jumped to next row");
				setSelectionCurrentRowToBeginning();
				//make sure current row is in view
				scrollToRow(getCurrentRow());
			}
			*/
			
			//whether or not in timing mode, maybe set previous outtime and then skip to next caption
			
			/*
			//if previous outtime is within blink of current intime, set previous outtime to the new intime - MIN_BLINK_TIME
			if( iwhich > 0 ){	//2nd row or more...
				//grab current intime
				if( (soldprevouttime==INFINITY) || (noldblinktime <= MIN_BLINK_TIME) ){
					_tbodyElement.rows[iwhich-1].cells[2].firstChild.textContent = (ntime-MIN_BLINK_TIME).toTimecode();
				}
			}
			*/

			//if( !playerIsPaused() ){ // if playing skip to next row... ){			
			if( !PlayerDispatch.playerIsPaused() ){
				//go to next row
				setCurrentRow(_currentRow+1);
				//debug("jumped to next row");
				setSelectionCurrentRowToBeginning();
				//make sure current row is in view
				scrollToRow(getCurrentRow());
			}
			
			
			
		}//setIntime
		function getOuttime(iwhich){
			var foo = _tbodyElement.rows[iwhich].cells[COL_OUT];
			//debug("TABLE:GetOuttime: outtime=["+foo.textContent+"]");
			return( _tbodyElement.rows[iwhich].cells[COL_OUT].textContent );
		}//getOuttime
		function setOuttime(iwhich, ntime){
			//debug("TABLE: setOuttime which=["+iwhich+"] time=["+ntime.toTimecode()+"]");
			if( iwhich < 0 ) return;
			
			if( _tbodyElement.rows[iwhich].cells[COL_OUT].firstChild ){//when insertBefore, this doesn't exist...
				if( !playerIsPaused() ){ // if playing set outtime on previous row... )	
					if(iwhich >= 0){
						var prevone = findPrevRealCaption(iwhich);
						if( prevone >= 0 ){
							_tbodyElement.rows[prevone].cells[COL_OUT].firstChild.textContent = ntime.toTimecode();
							DIRTY = true;
							_editor.makeDirty(true);
						}
					} else {//still at the top
						_tbodyElement.rows[iwhich].cells[COL_OUT].firstChild.textContent = ntime.toTimecode();
						DIRTY = true;
						_editor.makeDirty(true);
					}
				} else {
					_tbodyElement.rows[iwhich].cells[COL_OUT].firstChild.textContent = ntime.toTimecode();
					DIRTY = true;
					_editor.makeDirty(true);
				}	

			}
				
		}//setOuttime
		
		function findPrevRealCaption(istart){//find previous row with an intime
			if( istart == 0 ){
				if(  _tbodyElement.rows[0].cells[1].firstChild.textContent.trim().length > 0 ) return(0);
				else return(-1);
			} else {
				for(var i=istart-1; i>=0; i--){
					if( _tbodyElement.rows[i].cells[1].firstChild.textContent.trim().length > 0 )
						return(i);
				}
			}
			return(-1);
		}//findPrevRealCaption
		
		function unmarkAll(){
			var row;
			for( var i=0; i<getRowCount(); i++ ){
				cell = _tbodyElement.rows[i].cells[COL_NUM];
				//$(row, "td").removeClass( "multiselect" );
				//$("tbody tr td section").removeClass( "multiselect" );
				
				var foo = $(cell).text();
				if( foo.substring(0,1) == "*" )
					$(cell).text(foo.substring(1));
				
				row = _tbodyElement.rows[i];
				$(row).removeClass( "currow" );
			}
			//$(_currentRow).addClass( "currow" );//hilite current row
			//setCurrentRow(_currentRow);
		}//unmarkAll
		function markRow(r){
			var row = _tbodyElement.rows[r];
						
			//add asterisk to order number
			var foo = $(_tbodyElement.rows[r].cells[COL_NUM]).text();
			if( foo.substring(0,1) != "*" )
				$(_tbodyElement.rows[r].cells[COL_NUM]).text("*"+foo);
				
			$(row).addClass( "currow" );
		}//markRow
		function markRows(from, to){
			if( from <= to ){ //normal
				for( var i=from; i<=to; i++ ){
					markRow(i);
				}
			} else {	//backwards
				for( var i=from; i>=to; i-- ){
					markRow(i);
				}
			}
		}//markRows
		
		function clearCurrentTimes(){
			clearSomeTimes(_currentRow);
		}//clearCurrentTimes
		function clearAllTimes(){
			for(var i=0; i<getLength(); i++){
				clearSomeTimes(i);
			}
		}//clearAllTimes
		function clearSomeTimes(iwhich){
			//clear intime and outtime at some row
			_tbodyElement.rows[iwhich].cells[1].firstChild.textContent = "";
			_tbodyElement.rows[iwhich].cells[2].firstChild.textContent = "";
		}//clearSomeTimes
		function clearOutTimes(){
			for(var i=0; i<getLength(); i++){
				clearSomeOutTime(i);
			}
		}//clearOutTimes
		function clearSomeOutTime(iwhich){
			//clear outtime at some row
			_tbodyElement.rows[iwhich].cells[2].firstChild.textContent = "";
		}//clearSomeOutTimes
		
		function convertToDvsShell(){
			var SKIP_LENGTH = DVS_MINIMUM_SHELL_SLOT;//skip intervals less than this amount (1 sec)
			var newEvents = [];
			var lastOutTime = -1;
			var lastCap = "";
			var nout, dialogtime;
			var nin;
			var cap;
			
			//gather non-comment rows into CC array
			var ccevents = [];
			for( var i=0; i<getLength(); i++){
				if( getIntime(i).timecodeToNumber() == -1 ) 
					continue; //it's a comment row
					
				var ccev = {nin:getIntime(i).timecodeToNumber(), nout:getIntime(i).timecodeToNumber(), cctext:getText(i)};
				ccevents.push(ccev);
			}
			
			var dvsevents = [];
			//create DVS array:
			// 1 - add event before first element
			{
				if( ccevents[0].nin > SKIP_LENGTH ){ //only if there's room before the first caption
					var dvsev = {nin:0, nout:ccevents[0].nin, cue:"[CUE HERE...]"};
					dvsevents.push(dvsev);
					_editor.makeDirty(true);
				}
			}
			// 2 - process elements 1 -> n-1
			for(var i=0; i<ccevents.length-1; i++){
				var dvsev = {nin:ccevents[i].nin+textSpeakTime(ccevents[i].cctext), nout:ccevents[i+1].nin, cue:"["+ccevents[i].cctext+"...]"};
				dvsevents.push(dvsev);
				_editor.makeDirty(true);
			}
			// 3 - add event after last element
			{
				var dvsev = {nin:ccevents[ccevents.length-1].nin+textSpeakTime(ccevents[ccevents.length-1].cctext), 
							nout:INFINITY.timecodeToNumber(),
							cue:"["+ccevents[ccevents.length-1].cctext+"...]"};
				dvsevents.push(dvsev);
				_editor.makeDirty(true);
			}
			
			//replace existing table with new table from DVS array 
			setCadetMode( CADETMODE_DESCRIPTION );
			clearAndLeaveSingle();
			setCueText(0,"");//blank the first row
			for(var i=0; i<dvsevents.length; i++){
				//doStatus("dvsevents["+i+"] = ["+JSON.stringify(dvsevents[i])+"]");
				addRowAt(i+1, dvsevents[i].nin.toTimecode(), dvsevents[i].nout.toTimecode(), "");
				setCueText(i+1,dvsevents[i].cue);
			}
			setCurrentRow(0);
			
			
		}//convertToDvsShell
		function convertToDvsShellOld(){
			var SKIP_LENGTH = 1;//skip intervals less than this amount (1 sec)
			var newEvents = [];
			var lastOutTime = -1;
			var lastCap = "";
			var nout, dialogtime;
			var nin;
			var cap;
			
			//if the first timecode is more than 00:00:01.00 then the first dx could preceed the first caption
			if( getIntime(0).timecodeToNumber() > SKIP_LENGTH ){
				var someEv = {nin:0, nout:getIntime(0).timecodeToNumber(), cue:"[CUE HERE...]"};
				newEvents.push(someEv);
				_editor.makeDirty(true);
			}

			//everything in between up to second to last caption
			for(var i=0; i<getLength()-1; i++){
				if( getIntime(i).timecodeToNumber() == -1 ) continue; //it's a comment row
			
				nout=getOuttime(i).timecodeToNumber();
				//use estimated dialog time instead of the caption outtime
				dialogtime = dialogTime();
				nout = getIntime(i).timecodeToNumber() + dialogtime;
				//doStatus("row=["+(i+1)+"] cap=["+cap+"] dialogout=["+(getIntime(i).timecodeToNumber()+dialogtime).toTimecode()+"]");
				
				nin=getIntime(i+1).timecodeToNumber();
				if(nin-nout <= SKIP_LENGTH) continue; //ignore slots less than 1 second
				
				cap=getText(i);
				lastOutTime = nout;
				lastCap = cap;
				
				var someEv = {nin:nout, nout:nin, cue:"["+cap+"...]"};
				newEvents.push(someEv);
				_editor.makeDirty(true);
			}
			
			//put one after the last for post dx
			nout=lastOutTime;
			cap=lastCap;
			
			//doStatus("about to append last nin=["+nin+"] nout=["+nout+"]");
			//if( (nout != -1) && (nin != -1) ){
				//doStatus("appending last");
				var someEv = {nin:nout, nout:nout+5, cue:"["+lastCap+"...]"};
				newEvents.push(someEv);
				_editor.makeDirty(true);
			//}
				
			
			setCadetMode( CADETMODE_DESCRIPTION );
			clearAndLeaveSingle();
			setCueText(0,"");//blank the first row
			for(var i=0; i<newEvents.length; i++){
				//doStatus("newEvents["+i+"] = ["+JSON.stringify(newEvents[i])+"]");
				addRowAt(i+1, newEvents[i].nin.toTimecode(), newEvents[i].nout.toTimecode(), "");
				setCueText(i+1,newEvents[i].cue);
				//setIntime(i, newEvents[i].nin);
				//setOuttime(i, newEvents[i].nout);
				//setCueText(i, newEvents[i].cap);
				//setText(i,"");
			}
			setCurrentRow(0);
			
			
		}//convertToDvsShellOld
		
		function cueIntime(iwhich){
			//debug("TABLE: setIntime which=["+iwhich+"] time=["+ntime.toTimecode()+"]");
			var secs;
			secs = _tbodyElement.rows[iwhich].cells[1].textContent.timecodeToNumber(secs);
			if( secs >= 0 )//non-blank
				_editor.cueMedia(secs);
		}//cueIntime

		function getCurrentRow() {
			return _currentRow;
		}//getCurrentRow

		function setCurrentRow(r) {
		
			if(_tbodyElement.rows.length==0){
				return;
			}
		
			//debug("TABLE:setCurrentRow asking for r=["+r+"]");
			if( r > _tbodyElement.rows.length-1 ){
				r = _tbodyElement.rows.length-1;
				//debug("TABLE:setCurrentRow r>length-1, reset r=["+r+"]");
			}
			if( r < 0 ){
				//debug("TABLE:setCurrentRow asking for r=["+r+"]");
				r = 0;
			}
		
			if( SCREEN_REFRESH_ON ){
				//unhighlight all rows
				for( var i=0; i<_tbodyElement.rows.length; i++){
					unhighlight( i );
				}
			
				//highlight
				highlight(r);
			}
			
		
			_currentRow = r;
			
			//focus the caption if appropriate
			if( _inContentColumn ){
				if( RULER_SHOWING ){
					_tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild.nextSibling.focus(); //firstchild is the contenteditable <section>; Firefox unhappy with the parent focus
				} else {
					_tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild.focus(); //firstchild is the contenteditable <section>; Firefox unhappy with the parent focus
				}
			}
			//} else {
			//	_tbodyElement.rows[_currentRow].cells[COL_TEXT].firstChild.focus(); //firstchild is the contenteditable <section>; Firefox unhappy with the parent focus
			//}
				
			//update dialog time if in DVS mode
			updateDialogTime();
			
		}//setCurrentRow

		function setCurrentRowSave(r) {
			if( r > _tbodyElement.rows.length-1 ) r = _tbodyElement.rows.length-1;
			var lastCurrentRow = _currentRow;
		
			//do something if it changed
			//if( r != lastCurrentRow ){
				//unhighlight
				//if( lastCurrentRow >=1 )
				if( lastCurrentRow >=0 )
					unhighlight(lastCurrentRow);
			
				//highlight
				highlight(r);
		
				_currentRow = r;
			//}
		}//setCurrentRowSave
		
		function setRowValues(r,nin,nout,scap){
			_tbodyElement.rows[r].cells[COL_IN].innerHTML = nin.toTimecode();
			_tbodyElement.rows[r].cells[COL_OUT].innerHTML = nout.toTimecode();
			_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = scap;
		}//setRowValues
		
		function setTextAlign(irow, ialign){
		
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//do it to the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
			
					if( ialign == ALIGN_LEFT ){
						textAlignLeft(i);
						//document.execCommand("justifyLeft", false, false);
					} else if( ialign == ALIGN_CENTER ){
						textAlignCenter(i);
						//document.execCommand("justifyCenter", false, false);
					} else if( ialign == ALIGN_RIGHT ){
						textAlignRight(i);
						//document.execCommand("justifyRight", false, false);
					}
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
			
				if( ialign == ALIGN_LEFT ){
					textAlignLeft(irow);
					//document.execCommand("justifyLeft", false, false);
				} else if( ialign == ALIGN_CENTER ){
					textAlignCenter(irow);
					//document.execCommand("justifyCenter", false, false);
				} else if( ialign == ALIGN_RIGHT ){
					textAlignRight(irow);
					//document.execCommand("justifyRight", false, false);
				}
			}
			
		}//setTextAlign
		function getTextAlign(i){
			//var sfoo = $(_tbodyElement.rows[getCurrentRow()].cells[COL_TEXT]).attr("class");
			//debug("TABLE:getTextAlign: class=["+sfoo+"]");
			if( $(_tbodyElement.rows[i].cells[COL_TEXT]).hasClass("textAlignLeft") ){
				return(ALIGN_LEFT);
			} else if( $(_tbodyElement.rows[i].cells[COL_TEXT]).hasClass("textAlignCenter") ){
				return(ALIGN_CENTER);
			} else if( $(_tbodyElement.rows[i].cells[COL_TEXT]).hasClass("textAlignRight") ){
				return(ALIGN_RIGHT);
			} else return(ALIGN_CENTER);//default
		}//getTextAlign
		function textAlignLeft(irow) {
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignLeft");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignCenter");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignRight");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).addClass("textAlignLeft");
			//document.execCommand("justifyLeft"); //this leaves a <div style="text-align: right;">
		}//textAlignLeft
		function textAlignCenter(irow) {
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignLeft");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignCenter");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignRight");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).addClass("textAlignCenter");
			//document.execCommand("justifyCenter"); //this leaves a <div style="text-align: right;">
		}//textAlignCenter
		function textAlignRight(irow) {
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignLeft");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignCenter");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignRight");
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).addClass("textAlignRight");
			//document.execCommand("justifyRight"); //this leaves a <div style="text-align: right;">
		}//textAlignRight
		
		function setTextVAlign(irow, ialign){		

			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//do it to the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
			
					if( ialign == ALIGN_TOP ){
						textVAlignTop(i);
					} else if( ialign == ALIGN_BOTTOM ){
						textVAlignBottom(i);
					} else {
						textVAlignBottom(i);
					}
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
			
				if( ialign == ALIGN_TOP ){
					textVAlignTop(irow);
				} else if( ialign == ALIGN_BOTTOM ){
					textVAlignBottom(irow);
				} else {
					textVAlignBottom(irow);
				}
			}
			
			updateRowNumbers()

		}//setTextVAlign
		function getTextVAlign(i){
			//debug("TABLE:getTextAlign: class=["+sfoo+"]");
			if( $(_tbodyElement.rows[i].cells[COL_TEXT]).hasClass("textAlignTop") ){
				return(ALIGN_TOP);
			} else return(ALIGN_BOTTOM);//default
		}//getTextVAlign
		function textVAlignTop(irow) {
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).addClass("textAlignTop");
			//now goose player to display
			// toggleAutoRefreshCaptions(true);
		}//textVAlignTop
		function textVAlignBottom(irow) {
			$(_tbodyElement.rows[irow].cells[COL_TEXT]).removeClass("textAlignTop"); //just remove top, default is bottom
			// toggleAutoRefreshCaptions(true);
		}//textVAlignBottom
		function isTextTopAligned(i){
			//debug("TABLE:isTextTopAligned: class=["+sfoo+"]");
			if( $(_tbodyElement.rows[i].cells[COL_TEXT]).hasClass("textAlignTop") ){
				return(true);
			} else return(false);//default
		}//isTextTopAligned
		
		function makeBold(b) {
			//debug("TABLE:makeBold with ["+b+"]");
			//document.execCommand("styleWithCSS",true,true);
			
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//delete the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
					//setCurrentRow(i);
					selectAll(_tbodyElement.rows[i].cells[COL_TEXT].firstChild); 
					document.execCommand("bold");
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
	
				document.execCommand("bold");
			}
			
			
		}//makeBold
		function makeItalic(b) {
			//debug("TABLE: makeItalic");
			//document.execCommand("styleWithCSS",true,true);
			
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//delete the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
					//setCurrentRow(i);
					selectAll(_tbodyElement.rows[i].cells[COL_TEXT].firstChild); 
					document.execCommand("italic");
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
	
				document.execCommand("italic");
			}
			
		}//makeItalic
		function makeUnderline(b) {
			//debug("TABLE: makeUnderline");
			//document.execCommand("styleWithCSS",true,true);
			
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//delete the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
					//setCurrentRow(i);
					selectAll(_tbodyElement.rows[i].cells[COL_TEXT].firstChild); 
					document.execCommand("underline");
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
	
				document.execCommand("underline");
			}

		}//makeUnderline
		function makeColor(c) {
			//debug("TABLE: makeColor");
			//document.execCommand("styleWithCSS",true,true);
			
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//delete the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
					//setCurrentRow(i);
					selectAll(_tbodyElement.rows[i].cells[COL_TEXT].firstChild); 
					document.execCommand("foreColor",false,c);
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
	
				document.execCommand("foreColor",false,c);
			}

		}//makeColor
		function makeBGColor(c) {
			//debug("TABLE: makeColor");
			//document.execCommand("styleWithCSS",true,true);
			
			//blockData.length = 0;
			if( bMarking && (markRow1>=0) && (markRow2>=0) ){
				//sort
				if( markRow2 < markRow1 ){
					var temp = markRow1;
					markRow1 = markRow2;
					markRow2 = temp;
				}
				var oldcurrow = markRow1;

				//delete the block of events
				for( var i=markRow1; i<=markRow2; i++ ){
					//setCurrentRow(i);
					selectAll(_tbodyElement.rows[i].cells[COL_TEXT].firstChild); 
					document.execCommand("backColor",false,c);
				}
				
				//select old index for currentRow
				//setCurrentRow(oldcurrow)
		
			} else {
	
				document.execCommand("backColor",false,c);
			}

		}//makeBGColor
	
		function unhighlight(r){
			//if( r<1 || r > _tableElement.rows.length ) return;
			if( r<0 || r > _tbodyElement.rows.length-1 ) return;
			var row = _tbodyElement.rows[r];
			//row.style.backgroundColor=_bgnormal;//this.origColor;
			//row.cells[1].style.backgroundColor=_bgnormal;//this.origColor;
			//row.cells[2].style.backgroundColor=_bgnormal;//this.origColor;
			//$(row.cells[COL_NUM]).removeClass( "currow" );
			row.cells[COL_NUM].style.backgroundColor=_bgnormal;//this.origColor;
			$(row).removeClass( "currow" );
		}
	
		function highlight(r){
			//if( r<1 || r > _tableElement.rows.length ) return;
			if( r<0 || r > _tbodyElement.rows.length-1 ) return;
			var row = _tbodyElement.rows[r];

			row.cells[COL_NUM].style.backgroundColor=_bghilite;//this.origColor;

			$(row).addClass( "currow" );
			
			//if ruler is showing, kill ruler and reshow it at current row
			if( RULER_SHOWING ){
				killRuler();
				showRuler(r);
			}
		}

		function getText(r) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			return( _tbodyElement.rows[r].cells[COL_TEXT].textContent ) ;
		}//getText
		function setText(r,s) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			//_tbodyElement.rows[r].cells[COL_TEXT].innerHTML = s;
			_tbodyElement.rows[r].cells[COL_TEXT].textContent = s;
		}//setText
		function getCueText(r) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			return( _tbodyElement.rows[r].cells[COL_CUE].textContent ) ;
		}//getCueText
		function setCueText(r,s) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			_tbodyElement.rows[r].cells[COL_CUE].firstChild.textContent = s;
		}//setText
		function setCurrentText(s) {
			//debug("TABLE:setText row=["+r+"] val=["+s+"]");
			//_tbodyElement.rows[_currentRow].cells[COL_TEXT].textContent = s;
			document.execCommand("insertText",false,s);
		}//setCurrentText
		
		function getCellValue(r,c) {
			/*
				t:	table element
				r:	row (1-based)
				c:	column (1-based)
			*/
			//var table = document.getElementById('mytable');
			//for (var r = 0, n = table.rows.length; r < n; r++) {
			//	for (var c = 0, m = table.rows[r].cells.length; c < m; c++) {
			//		alert(table.rows[r].cells[c].innerHTML);
			//	}//each c
			//}//each r
		
			var maxrows=_tbodyElement.rows.length-1;
			var maxcols=_tbodyElement.rows[0].cells.length-1;
		
			if( (r > maxrows) || (c > maxcols) ){
				alert("invalid row/col=["+r+"/"+c+"], rowmax=["+maxrows+"] colmax=["+maxcols+"]");
				return "";
			} else {
				return _tbodyElement.rows[r].cells[c].innerHTML;
			}
	
		} //getCellValue
		
		function scrollToRow(i){
			//scroll current row into view
			var rowpos = $(_tbodyElement.rows[i]).position();
			var offsetdown;
			if( i==0)
				offsetdown = 0;
			else
				offsetdown = $(_tbodyElement.rows[i-1]).height(); //height of preceeding row
			//$('#divtable').scrollTop(rowpos.top-50);
			$('#divtable').scrollTop(rowpos.top-offsetdown);
		}//scrollToRow
		
		function gotoCurrent(){
			scrollToRow(_currentRow);
		}//gotoCurrent

		function clear() {
			//complete clear, leaves no rows in tbody
			//debug("TABLE: clear");
			var new_tbody = document.createElement('tbody');
			//populate_with_new_rows(new_tbody);
			_tableElement.replaceChild(new_tbody, _tbodyElement)//clear
			_currentRow = -1;
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];			
			/*
			for( var i=0, len=_tbodyElement.rows.length; i<len-1; i++ ){
				_tbodyElement.rows[0].remove();
			}
			//didn't remove the first one, jam it's values
			*/
			
		}//clear

		function clearAndLeaveSingle() {
			//debug("TABLE: clearAndLeaveSingle");
			clear();
			//update _tbodyElement
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			//insert a single blank row
			//var row = _tableElement.insertRow(1);
			
			/*
			var row = _tbodyElement.insertRow(0);
			row.innerHTML = "<td>1</td><td class='time-column'><section class='time-column' contenteditable>"+ZEROS+"</section></td><td class='time-column'><section class='time-column' contenteditable>"+INFINITY+"</section></td><td class='content-column' tabindex='-1'><section contenteditable>"+DEFAULT_CAPTION+"</section></td>"
			_currentRow = 0;//trigger a change
			setCurrentRow(0);
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			*/
			//addRowAt(0, ZEROS, INFINITY, DEFAULT_CAPTION, false);
			addRowAt(0, "", "", DEFAULT_CAPTION, false);
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			
			setSelectionCurrentRowToBeginning();

		}//clearAndLeaveSingle

		function addRowBefore(sin, sout, scap) {
			addRowAt(getCurrentRow(), sin.toTimecode(), sout.toTimecode(), scap);
		}//addRowBefore

		function addRowAfter(sin, sout, scap) {
			addRowAt(getCurrentRow()+1, sin.toTimecode(), sout.toTimecode(), scap);
		}//addRowAfter

		function getMediaTime(){
			var ntime;
			ntime = $("video")[0].currentTime;
			return( ntime );
		}//getMediaTime
		
		function fixupTabIndex(){
			for(var i=0; i<_tbodyElement.rows.length; i++){
				$(_tbodyElement.rows[i].cell[COL_TEXT]).attr("tabindex","-1");
			}
		}//fixupTabIndex

		function addRowAt(iwhere, sin, sout, scap, bishtml) {
			//debug("TABLE:addRowAt enter iwhere=["+iwhere+"] sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");
			if(iwhere<0) iwhere=0;
			if( iwhere > _tbodyElement.rows.length-1 ) iwhere = _tbodyElement.rows.length; //add to end
			
			unhighlight( _currentRow );
			
			/*NEW
			//figure out timecodes
			var curin=0;
			var curout=0;
			if( _currentRow >= 0 ){
				curin = getIntime(_currentRow);
				curout = getOuttime( _currentRow ) ;
			} else {
				
			}
			*/	
			
			var row = _tbodyElement.insertRow(iwhere);
			
			// Insert new cells (<td> elements)
			//var cell1 = row.insertCell(0);
			var cell1 = document.createElement("TH"); //so the table us fully accessible to screen readers
			row.appendChild(cell1);
			
			
			
			var cell2 = row.insertCell(1);
			var cell3 = row.insertCell(2);
			var cell4 = row.insertCell(3);
			var cell5 = row.insertCell(4);
			//$(cell1).attr("class","order-column col0");
			$(cell1).attr({class:"order-column col0", scope:"row"});
			$(cell2).attr("class","time-column col1");
			$(cell3).attr("class","time-column col2");
			$(cell4).attr("class","cue-column col3");
			$(cell5).attr({class:"content-column col4", tabindex:"-1"});
			//$(cell5).attr("tabindex","-1"); //this allows .focus() through Javascript for some reason
			
			var newSection, newText;

			if( scap.length > 0 ){
				//debug("TABLE: addRowAt: scap length>0 explicit values charCodeAt(0)=["+scap.charCodeAt(0)+"]");
				//debug("scap[0]=["+scap.charCodeAt(0)+"]");
				//debug("TABLE: addRowAt: scap.length>0, sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");

				// Add passed text to the new cells:
				cell1.innerHTML = (_currentRow+1);

				//cell2.innerHTML = sin;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(sin);
				newSection.appendChild(newText); 
				cell2.appendChild(newSection);

				//cell3.innerHTML = sout;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(sout);
				newSection.appendChild(newText); 
				cell3.appendChild(newSection);

				//cell4.innerHTML = cue;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","cue-column");
				newText = document.createTextNode("[...]");
				newSection.appendChild(newText); 
				cell4.appendChild(newSection);

				//cell5.innerHTML = "<section class='content-column' contenteditable>"+scap+"</section>";//scap
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","content-column");
				newSection.setAttribute("style", "color:#fefefe; background-color:#010101;")
				newText = document.createTextNode(scap.trim()+" "); //trim all whitespace, leave space at end
				newSection.appendChild(newText); 
				cell5.appendChild(newSection);
				if( bishtml ){
					//debug("TABLE:addRowAt: jamming htmltext");
					cell5.innerHTML = scap;
				}
				
			} else {
				//debug("TABLE: addRowAt: default values, sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");
				
				/*NEW
				var slsin = ZEROS;	//virgin intime
				var slsout = INFINITY;	//virgin outtime
				
				var igoosecurout = 0

				var ncurtime = Number(getMediaTime());
				var nprevout = ncurtime - MIN_BLINK_TIME;
				var sthisin = ncurtime.toTimecode();
				var sthisout = INFINITY;					
				nprevout = nprevout >= 0 ? nprevout : INFINITY.timecodeToNumber();
				
				//set previous outtime
				setOuttime( _currentRow, nprevout );
				
				//get ready to set in/out times of new row
				slsin = sthisin;
				slsout = sthisout;
				*/	
				
				// Add default text to the new cells:
				cell1.innerHTML = (_currentRow+1);
				
				//cell2.innerHTML = sin;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				//newText = document.createTextNode(slsin);
				newText = document.createTextNode(sin);
				newSection.appendChild(newText); 
				cell2.appendChild(newSection);

				//cell3.innerHTML = sout;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				//newText = document.createTextNode(slsout);
				newText = document.createTextNode(sout);
				newSection.appendChild(newText); 
				cell3.appendChild(newSection);

				//cell4.innerHTML = scue;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","cue-column");
				//newText = document.createTextNode(slsout);
				newText = document.createTextNode("[...]");
				newSection.appendChild(newText); 
				cell4.appendChild(newSection);

				//cell5.innerHTML = sout;
				newSection = document.createElement("section");
				newSection.setAttribute("class","content-column");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("style", "color:#fefefe; background-color:#010101;")
				//newSection.innerHTML = DEFAULT_CAPTION; //"\u00A0"==160==&nbsp;
				newText = document.createTextNode(DEFAULT_CAPTION); //"\u00A0"==160==&nbsp;
				newSection.appendChild(newText); 
				cell5.appendChild(newSection);
			}
			
			//set text to default colors
			//cell4.firstElementChild.focus();
			//setTimeout(function() { cell4.firstElementChild.firstChild.focus(); }, 1000);
			selectAll(cell5.firstChild); 
			//debug("TABLE:addRowAt: making color=["+DEFAULT_FORECOLOR+"]");
			makeColor(DEFAULT_FORECOLOR);//"white");
			makeBGColor(DEFAULT_BACKCOLOR);//"black");  
			clearSelection();

			//highlight( iwhere );
			
			
			//row number fixup			
			updateRowNumbers();
			
			//internal index fixup: ccurrent row is now one greater than it was
			//_currentRow++;
			//_currentRow = iwhere;
			//_currentRow = iwhere-1;
			
			//select the  row that was just inserted
			//setCurrentRow(_currentRow+1);
			setCurrentRow(iwhere);

			
			//set focus the caption cell in that row
			$("section[contenteditable]", $(row)).focus();	//this works on all os/browser platforms; tested Firefox/Chrome/Safari/IE/Edge/OSX/WIN10
			//cell4.firstChild.focus(); //doesn't work in FF
			//setTimeout(function() { cell4.firstChild.focus(); }, 1000);
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];	
			
			//selectAll(cell3.firstChild); 
			setSelectionCurrentRowToBeginning(cell5.firstChild); 
			//setSelectionCurrentRowToBeginning(_tbodyElement.rows[_currentRow].cells[COL_TEXT]);
			//setTimeout(function() { cell4.firstElementChild.focus(); }, 0);
			//setTimeout(function() { cell4.focus(); }, 0);
			/*
			var char = 1, sel;
			cell4.firstChild.firstChild.focus();
			if (document.selection) {
			  sel = document.selection.createRange();
			  sel.moveStart('character', char);
			  sel.select();
			}
			else {
			   sel = window.getSelection();
			  sel.collapse(content.firstChild, char);
			}	*/	
			
			refreshCaptions();
			
			var objDiv = document.getElementById("cadettable");
			objDiv.scrollTop = objDiv.scrollHeight - 25; //keep it in view above the bottom
			
			_inContentColumn = true;
			
		}//addRowAt
		function addRowAtOOOOOLD(iwhere, sin, sout, scap, bishtml) {
			debug("TABLE:addRowAt enter iwhere=["+iwhere+"] sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");
			if(iwhere<0) iwhere=0;
			if( iwhere > _tbodyElement.rows.length-1 ) iwhere = _tbodyElement.rows.length; //add to end
			
			unhighlight( _currentRow );
			
			//figure out timecodes
			var curin=0;
			var curout=0;
			if( _currentRow >= 0 ){
				curin = getIntime(_currentRow);
				curout = getOuttime( _currentRow ) ;
			} else {
				
			}
			//debug("TABLE:addRowAt: current in=["+curin+"] out=["+curout+"]");
			//if( getIntime(_currentRow) == ZEROS ) debug("in==ZEROS");
			//if( getIntime(_currentRow) == INFINITY ) debug("in==INFINITY");
			//if( getOuttime(_currentRow) == ZEROS ) debug("out==ZEROS");
			//if( getOuttime(_currentRow) == INFINITY ) debug("out==INFINITY");
			
			
			var row = _tbodyElement.insertRow(iwhere);
			//row.innerHTML = "<td>1</td><td>00:00:00.00</td><td>00:00:00.00</td><td>Put caption here.</td>";
			
			// Insert new cells (<td> elements)
			var cell1 = row.insertCell(0);
			var cell2 = row.insertCell(1);
			var cell3 = row.insertCell(2);
			var cell4 = row.insertCell(3);
			$(cell1).attr("class","order-column");
			//$(cell2).attr("contenteditable","true");
			$(cell2).attr("class","time-column");
			//$(cell3).attr("contenteditable","true");
			$(cell3).attr("class","time-column");
			//$(cell4).attr("contenteditable","true");
			$(cell4).attr("class","content-column");
			$(cell4).attr("tabindex","-1"); //this allows .focus() through Javascript for some reason
			//$(cell4).attr("style","background-color:#fffffe");
			
			var newSection, newText;
			//if( (scap.length > 0) && (scap.charCodeAt(0)!=10)){
			//if( (scap.length > 0) && (scap.charCodeAt(0)!=32)){ //Safari shows space when blank
			//if( scap.trim().length > 0 ){
			if( scap.length > 0 ){
				//debug("TABLE: addRowAt: scap length>0 explicit values charCodeAt(0)=["+scap.charCodeAt(0)+"]");
				//debug("scap[0]=["+scap.charCodeAt(0)+"]");
				debug("TABLE: addRowAt: scap.length>0, sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");

				// Add passed text to the new cells:
				cell1.innerHTML = (_currentRow+1);

				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(sin);
				newSection.appendChild(newText); 
				cell2.appendChild(newSection);

				//cell3.innerHTML = sout;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(sout);
				newSection.appendChild(newText); 
				cell3.appendChild(newSection);
				//cell3.setAttribute("contenteditable","true");
				//cell3.setAttribute("class","time-column");

				//cell4.innerHTML = "<section class='content-column' contenteditable>"+scap+"</section>";//scap
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","content-column");
				newSection.setAttribute("style", "color:#fefefe; background-color:#010101;")
				//newText = document.createTextNode(scap);
				newText = document.createTextNode(scap.trim()+" "); //trim all whitespace, leave space at end
				newSection.appendChild(newText); 
				cell4.appendChild(newSection);
				if( bishtml ){
					//debug("TABLE:addRowAt: jamming htmltext");
					cell4.innerHTML = scap;
				}
				
			} else {
				debug("TABLE: addRowAt: default values, sin=["+sin+"] sout=["+sout+"] scap=["+scap+"]");
				
				//if in transcribe mode, then fudge the times; set previous outtime to previous intime+5sec, set this intime to new prev outtime+0.15, this outtime=INFINITY
				//if( _editMode == EDITMODE_TRANSCRIBE ){
				
					
					var slsin = ZEROS;	//virgin intime
					var slsout = INFINITY;	//virgin outtime
					
					var igoosecurout = 0
					/*
					if( _currentRow >= 0 ){
						igoosecurout = getOuttime(_currentRow).timecodeToNumber();
						if( getOuttime(_currentRow) == INFINITY ){ //update current outtime
							//debug("TABLE:addRowAt goosing time currentRow=["+_currentRow+"] where=["+iwhere+"]");
							var curout = getIntime(_currentRow);
							var icurout = curout.timecodeToNumber();
							igoosecurout = icurout + MIN_SCREEN_TIME;
							setOuttime( _currentRow, igoosecurout );
						
						}
						slsin = (igoosecurout + MIN_BLINK_TIME).toTimecode();
						slsout = (igoosecurout + MIN_BLINK_TIME + MIN_SCREEN_TIME).toTimecode();
					}
					*/
					
					/**/
					var ncurtime = Number(getMediaTime());
					var nprevout = ncurtime - MIN_BLINK_TIME;
					var sthisin = ncurtime.toTimecode();
					var sthisout = INFINITY;					
					nprevout = nprevout >= 0 ? nprevout : INFINITY.timecodeToNumber();
					
					//set previous outtime
					setOuttime( _currentRow, nprevout );
					
					//get ready to set in/out times of new row
					slsin = sthisin;
					slsout = sthisout;
					
					
				//} else {
				//}
				
				
				
				
				// Add default text to the new cells:
				cell1.innerHTML = (_currentRow+1);
				
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(slsin);
				newSection.appendChild(newText); 
				cell2.appendChild(newSection);

				//cell3.innerHTML = sout;
				newSection = document.createElement("section");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("class","time-column");
				newText = document.createTextNode(slsout);
				newSection.appendChild(newText); 
				cell3.appendChild(newSection);

				newSection = document.createElement("section");
				newSection.setAttribute("class","content-column");
				newSection.setAttribute("contenteditable","true");
				newSection.setAttribute("style", "color:#fefefe; background-color:#010101;")
				//newSection.innerHTML = DEFAULT_CAPTION; //"\u00A0"==160==&nbsp;
				newText = document.createTextNode(DEFAULT_CAPTION); //"\u00A0"==160==&nbsp;
				newSection.appendChild(newText); 
				cell4.appendChild(newSection);
			}
			
			//set text to default colors
			//cell4.firstElementChild.focus();
			//setTimeout(function() { cell4.firstElementChild.firstChild.focus(); }, 1000);
			selectAll(cell4.firstChild); 
			//debug("TABLE:addRowAt: making color=["+DEFAULT_FORECOLOR+"]");
			makeColor(DEFAULT_FORECOLOR);//"white");
			makeBGColor(DEFAULT_BACKCOLOR);//"black");  
			clearSelection();

			//highlight( iwhere );
			
			
			//row number fixup			
			updateRowNumbers();
			
			//internal index fixup: ccurrent row is now one greater than it was
			//_currentRow++;
			//_currentRow = iwhere;
			//_currentRow = iwhere-1;
			
			//select the  row that was just inserted
			//setCurrentRow(_currentRow+1);
			setCurrentRow(iwhere);

			
			//set focus the caption cell in that row
			$("section[contenteditable]", $(row)).focus();	//this works on all os/browser platforms; tested Firefox/Chrome/Safari/IE/Edge/OSX/WIN10
			//cell4.firstChild.focus(); //doesn't work in FF
			//setTimeout(function() { cell4.firstChild.focus(); }, 1000);
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];	
			
			//selectAll(cell3.firstChild); 
			setSelectionCurrentRowToBeginning(cell4.firstChild); 
			//setSelectionCurrentRowToBeginning(_tbodyElement.rows[_currentRow].cells[COL_TEXT]);
			//setTimeout(function() { cell4.firstElementChild.focus(); }, 0);
			//setTimeout(function() { cell4.focus(); }, 0);
			/*
			var char = 1, sel;
			cell4.firstChild.firstChild.focus();
			if (document.selection) {
			  sel = document.selection.createRange();
			  sel.moveStart('character', char);
			  sel.select();
			}
			else {
			   sel = window.getSelection();
			  sel.collapse(content.firstChild, char);
			}	*/	
			
			refreshCaptions();
			
			var objDiv = document.getElementById("cadettable");
			objDiv.scrollTop = objDiv.scrollHeight - 25; //keep it in view above the bottom
			
		}//addRowAtOOOOOOLD
		
function doKeyboardEvent(el, etype){
	var event = document.createEvent('Event'); event.initEvent('keydown', true, true); event.keyCode = 9;
}//doKeyboardEvent	
		
function eventFire(el, etype){
	if (el.fireEvent) {
		el.fireEvent('on' + etype);
	} else {
		var evObj = document.createEvent('Events');
		evObj.initEvent(etype, true, false);
		el.dispatchEvent(evObj);
	}
}//eventFire

		/*function addRowBeforeOld(iwhere, sin, sout, scap) {
			debug("TABLE: addRowBefore");
			if(iwhere<0) iwhere=0;
			if( iwhere > _tbodyElement.rows.length-1 ) iwhere = _tbodyElement.rows.length; //add to end
			
			unhighlight( _currentRow );
			
			var row = _tbodyElement.insertRow(iwhere);
			//row.innerHTML = "<td>1</td><td>00:00:00.00</td><td>00:00:00.00</td><td>Put caption here.</td>";
			
			// Insert new cells (<td> elements)
			var cell1 = row.insertCell(0);
			var cell2 = row.insertCell(1);
			var cell3 = row.insertCell(2);
			var cell4 = row.insertCell(3);
			$(cell4).attr("contenteditable","true");
			
			if(scap.length() > 0){
				//alert("TABLE: addRowBefore: explicit values");
				// Add passed text to the new cells:
				cell1.innerHTML = (_currentRow+1);
				cell2.innerHTML = sin;
				cell3.innerHTML = sout;
				cell4.innerHTML = scap;
			} else {
				//alert("TABLE: addRowBefore: default values");
				// Add default text to the new cells:
				cell1.innerHTML = (_currentRow+1);
				cell2.innerHTML = "00:00:00.00";
				cell3.innerHTML = "24:00:00.00";
				cell4.innerHTML = "&nbsp;";
			}
			
			highlight( iwhere );
			
			
			//row number fixup			
			updateRowNumbers();
			
			//internal index fixup: ccurrent row is now one greater than it was
			//_currentRow++;
			_currentRow = iwhere;
			
			//select the previous row that was just inserted
			setCurrentRow(_currentRow);
			
			//set focus the caption cell in that row
			//$("td[contenteditable]", $(row)).focus();	//this also works
			cell4.focus();

		}//addRowBeforeOld*/
	
		/*function addRowAfterOld(sin, sout, scap) {
			debug("TABLE: addRowAfter");
			var row = _tableElement.insertRow(_currentRow + 1);
			//row.innerHTML = "<td>1</td><td>00:00:00.00</td><td>00:00:00.00</td><td>Put caption here.</td>";
			
			// Insert new cells (<td> elements)
			var cell1 = row.insertCell(0);
			var cell2 = row.insertCell(1);
			var cell3 = row.insertCell(2);
			var cell4 = row.insertCell(3);
			$(cell4).attr("contenteditable","true");
			
			if(sin){
				//alert("TABLE: addRowBefore: explicit values");
				// Add passed text to the new cells:
				cell1.innerHTML = _currentRow;
				cell2.innerHTML = sin;
				cell3.innerHTML = sout;
				cell4.innerHTML = scap;
			} else {
				//alert("TABLE: addRowBefore: default values");
				// Add default text to the new cells:
				cell1.innerHTML = _currentRow;
				cell2.innerHTML = "00:00:00.00";
				cell3.innerHTML = "24:00:00.00";
				cell4.innerHTML = "&nbsp;";
			}
			
			//row number fixup			
			updateRowNumbers();
			
			//internal index fixup: current row hasn't changed
			//_currentRow++;
			
			//select the row that was just inserted
			setCurrentRow(_currentRow+1);
			
			//set focus the caption cell in that row
			//$("td[contenteditable]", $(row)).focus();	//this also works
			cell4.focus();
			
		}//addRowAfterOld*/
		
		function deleteEvent() {
			_tbodyElement.deleteRow(_currentRow);
			//update _tbody element
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			
			//row number fixup			
			updateRowNumbers();
			
			//select the row that was just deleted; table data moves up, currentRow is the same number unless deleting last row
			//if( _currentRow >
			if( _currentRow <= _tbodyElement.rows.length-1 ) 
				setCurrentRow(_currentRow);
			else
				setCurrentRow(_tbodyElement.rows.length-1);
			
		}//deleteEvent
		function deleteSomeEvent(i) {
			if( i>=_tbodyElement.count ) return;
			_tbodyElement.deleteRow(i);
			//update _tbody element
			_tbodyElement = _tableElement.getElementsByTagName("tbody")[0];
			
			//row number fixup			
			updateRowNumbers();
			
			//select the row that was just deleted; table data moves up, currentRow is the same number unless deleting last row
			//if( _currentRow >
			if( _currentRow <= _tbodyElement.rows.length-1 ) 
				setCurrentRow(_currentRow);
			else
				setCurrentRow(_tbodyElement.rows.length-1);
			
		}//deleteEvent
	
		function updateRowNumbers(){
			//alert("STUB updateRowNumbers");
			if( SCREEN_REFRESH_ON ){
				for(var i=0; i<_tbodyElement.rows.length; i++){
					_tbodyElement.rows[i].cells[COL_NUM].innerHTML = (i+1).toString() + (isTextTopAligned(i)?"^":"");
				}
			}

		}//updateRowNumbers
		
		//////////////////////////////////////////////
		//	returnHandler
		//	Keystroke handler, normalizes return characters among browsers
		//////////////////////////////////////////////
		function returnHandler(e) {
			//alert("TABLE:returnHandler");
			
			if( !_inContentColumn ){
				//debug("TABLE:returnHandler: not in content column, no returns");
				e.preventDefault();
				return false;
			} else {
				//remove &nbsp;==\u00a0==#160
				var sfoo = getText(_currentRow);
				//debug("TABLE:returnHandler: ---------> sfoo=["+sfoo+"] codes1/2=["+sfoo.charCodeAt(0)+"/"+sfoo.charCodeAt(1)+"]")
				if( sfoo.indexOf("\u00a0") >= 0 ){
					//debug("TABLE:returnHandler: ---------> found nbsp sfoo=["+sfoo+"]")
					sfoo = sfoo.replace("\u00a0", "");
					//setText(_currentRow, sfoo);
				}
			}

			
			
			
			var doxExec = false;

			try {
				doxExec = document.execCommand('insertBrOnReturn', false, true);
			}
			catch (error) {
				// IE throws an error if it does not recognize the command...
			}

			if (doxExec) {
				debug("TABLE:returnHandler: NORMAL NO HACKS returning TRUE");
				// Hurray, no dirty hacks needed !
				e.stopPropagation();
				return true;
			}
			// Standard
			else if (window.getSelection) {
				debug("TABLE:returnHandler: NO EXECCOMMAND");
				//return true;//????
				
						/*
						//trying this
						//append a space
						insertCurrentRowSelectionText(" ");
						//move cursor back one character to leave extra space
						moveCaret(window, -1);
						*/

				var selection = window.getSelection(),
				range = selection.getRangeAt(0),
				br = document.createElement('br');

				range.deleteContents();

				range.insertNode(br);

				range.setStartAfter(br);

				range.setEndAfter(br);

				range.collapse(false);

				selection.removeAllRanges();

				selection.addRange(range);
				
				

				e.stopPropagation();
				e.preventDefault()
				return false;
			}
			// Standard
			/*else if (window.getSelection) {
				debug("TABLE:returnHandler: NO EXECCOMMAND");
				e.stopPropagation();
				//return true;//????

				var selection = window.getSelection(),
				range = selection.getRangeAt(0),
				br = document.createElement('br');
				textNode = document.createTextNode("\u00a0");
				range.deleteContents();
				range.insertNode(br);
				range.collapse(false);
				range.insertNode(textNode);
				range.selectNodeContents(textNode);

				selection.removeAllRanges();
				selection.addRange(range);
			}*/
			// IE
			else if ($.browser.msie) {
				debug("TABLE:returnHandler: MSI");
				e.preventDefault();

				var range = document.selection.createRange();

				range.pasteHTML('<BR><SPAN class="--IE-BR-HACK"></SPAN>');

				// Move the caret after the BR
				range.moveStart('character', 1);

				return false;
			}

			debug("TABLE:returnHandler: DEFAULT AND PRAY");
			// Last resort, just use the default browser behavior and pray...
			return true;
		}//returnHandler	
		
		
		//tableToEvents
		function tableToEvents(){
			debug("TABLE:tableToEvents ENTER")
		} //tableToEvents
		
		function refreshCaptions(){
			//get the track src, append a new random number and set
			//var sfoo = $("#cadetvideo > track")[0].src;
			//debug("TABLE:refreshCaptions: old track source=["+sfoo+"]");
			if( _editor )
				_editor.refreshCaptions();
		}//refreshCaptions
		

	} // CadetTable Module constructor
	
	window.onfocus=function(event){
    	//debug("TABLE: window.onfocus");
	}
	            
            
	}); // ready


}) (); // CadetTable



